#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93 (BSDI)";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYEMPTY (-1)
#define YYLEX yylex()
#define yyclearin (yychar=YYEMPTY)
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "ns_parser.y"
#if !defined(lint) && !defined(SABER)
static char rcsid[] = "$Id: ns_parser.y,v 8.80 2002/05/24 03:05:01 marka Exp $";
#endif /* not lint */

/*
 * Copyright (c) 1996-2000 by Internet Software Consortium.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
 * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/* Global C stuff goes here. */

#include "port_before.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/un.h>

#include <netinet/in.h>
#include <arpa/nameser.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <limits.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <time.h>

#include <isc/eventlib.h>
#include <isc/logging.h>

#include <isc/dst.h>

#include "port_after.h"

#include "named.h"
#include "ns_parseutil.h"
#include "ns_lexer.h"

#define SYM_ZONE	0x010000
#define SYM_SERVER	0x020000
#define SYM_KEY		0x030000
#define SYM_ACL		0x040000
#define SYM_CHANNEL	0x050000
#define SYM_PORT	0x060000

#define SYMBOL_TABLE_SIZE 29989		/* should always be prime */
static symbol_table symtab;

#define AUTH_TABLE_SIZE 397		/* should always be prime */
static symbol_table authtab = NULL;
static symbol_table channeltab = NULL;

static zone_config current_zone;
static int should_install;

static options current_options;
static int seen_options;
static int logged_options_error;

static controls current_controls;

static int seen_topology;

static server_config current_server;
static int seen_server;

static char *current_algorithm;
static char *current_secret;

static log_config current_logging;
static int current_category;
static int chan_type;
static int chan_level;
static u_int chan_flags;
static int chan_facility;
static char *chan_name;
static int chan_versions;
static u_long chan_max_size;

static log_channel lookup_channel(char *);
static void define_channel(const char *, log_channel);
static char *canonical_name(char *);

int yyparse();
	
#line 105 "ns_parser.y"
typedef union {
	char *			cp;
	int			s_int;
	long			num;
	u_long			ul_int;
	u_int16_t		us_int;
	struct in_addr		ip_addr;
	ip_match_element	ime;
	ip_match_list		iml;
	rrset_order_list	rol;
	rrset_order_element	roe;
	struct dst_key *	keyi;
	enum axfr_format	axfr_fmt;
} YYSTYPE;
#line 132 "y.tab.c"
#define L_EOS 257
#define L_IPADDR 258
#define L_NUMBER 259
#define L_STRING 260
#define L_QSTRING 261
#define L_END_INCLUDE 262
#define T_INCLUDE 263
#define T_OPTIONS 264
#define T_DIRECTORY 265
#define T_PIDFILE 266
#define T_NAMED_XFER 267
#define T_DUMP_FILE 268
#define T_STATS_FILE 269
#define T_MEMSTATS_FILE 270
#define T_FAKE_IQUERY 271
#define T_RECURSION 272
#define T_FETCH_GLUE 273
#define T_HITCOUNT 274
#define T_PREFERRED_GLUE 275
#define T_QUERY_SOURCE 276
#define T_LISTEN_ON 277
#define T_PORT 278
#define T_ADDRESS 279
#define T_RRSET_ORDER 280
#define T_ORDER 281
#define T_NAME 282
#define T_CLASS 283
#define T_CONTROLS 284
#define T_INET 285
#define T_UNIX 286
#define T_PERM 287
#define T_OWNER 288
#define T_GROUP 289
#define T_ALLOW 290
#define T_DATASIZE 291
#define T_STACKSIZE 292
#define T_CORESIZE 293
#define T_DEFAULT 294
#define T_UNLIMITED 295
#define T_FILES 296
#define T_VERSION 297
#define T_HOSTNAME 298
#define T_HOSTSTATS 299
#define T_HOSTSTATSMAX 300
#define T_DEALLOC_ON_EXIT 301
#define T_TRANSFERS_IN 302
#define T_TRANSFERS_OUT 303
#define T_TRANSFERS_PER_NS 304
#define T_TRANSFER_FORMAT 305
#define T_MAX_TRANSFER_TIME_IN 306
#define T_SERIAL_QUERIES 307
#define T_ONE_ANSWER 308
#define T_MANY_ANSWERS 309
#define T_NOTIFY 310
#define T_EXPLICIT 311
#define T_NOTIFY_INITIAL 312
#define T_AUTH_NXDOMAIN 313
#define T_MULTIPLE_CNAMES 314
#define T_USE_IXFR 315
#define T_MAINTAIN_IXFR_BASE 316
#define T_CLEAN_INTERVAL 317
#define T_INTERFACE_INTERVAL 318
#define T_STATS_INTERVAL 319
#define T_MAX_LOG_SIZE_IXFR 320
#define T_HEARTBEAT 321
#define T_USE_ID_POOL 322
#define T_MAX_NCACHE_TTL 323
#define T_HAS_OLD_CLIENTS 324
#define T_RFC2308_TYPE1 325
#define T_LAME_TTL 326
#define T_MIN_ROOTS 327
#define T_TREAT_CR_AS_SPACE 328
#define T_LOGGING 329
#define T_CATEGORY 330
#define T_CHANNEL 331
#define T_SEVERITY 332
#define T_DYNAMIC 333
#define T_FILE 334
#define T_VERSIONS 335
#define T_SIZE 336
#define T_SYSLOG 337
#define T_DEBUG 338
#define T_NULL_OUTPUT 339
#define T_PRINT_TIME 340
#define T_PRINT_CATEGORY 341
#define T_PRINT_SEVERITY 342
#define T_SORTLIST 343
#define T_TOPOLOGY 344
#define T_SERVER 345
#define T_LONG_AXFR 346
#define T_BOGUS 347
#define T_TRANSFERS 348
#define T_KEYS 349
#define T_SUPPORT_IXFR 350
#define T_EDNS 351
#define T_ZONE 352
#define T_IN 353
#define T_CHAOS 354
#define T_HESIOD 355
#define T_TYPE 356
#define T_MASTER 357
#define T_SLAVE 358
#define T_STUB 359
#define T_RESPONSE 360
#define T_HINT 361
#define T_MASTERS 362
#define T_TRANSFER_SOURCE 363
#define T_PUBKEY 364
#define T_ALSO_NOTIFY 365
#define T_DIALUP 366
#define T_FILE_IXFR 367
#define T_IXFR_TMP 368
#define T_TRUSTED_KEYS 369
#define T_ACL 370
#define T_ALLOW_UPDATE 371
#define T_ALLOW_QUERY 372
#define T_ALLOW_TRANSFER 373
#define T_ALLOW_RECURSION 374
#define T_BLACKHOLE 375
#define T_SEC_KEY 376
#define T_ALGID 377
#define T_SECRET 378
#define T_CHECK_NAMES 379
#define T_WARN 380
#define T_FAIL 381
#define T_IGNORE 382
#define T_FORWARD 383
#define T_FORWARDERS 384
#define T_ONLY 385
#define T_FIRST 386
#define T_IF_NO_ANSWER 387
#define T_IF_NO_DOMAIN 388
#define T_YES 389
#define T_TRUE 390
#define T_NO 391
#define T_FALSE 392
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   31,   31,   32,   32,   32,   32,   32,   32,   32,
   32,   32,   32,   32,   32,   33,   42,   34,   43,   43,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   46,
   44,   44,   44,   44,   44,   44,   44,   49,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   35,
   53,   53,   54,   54,   54,   54,   54,   54,   15,   15,
   12,   12,   13,   13,   14,   14,   16,    6,    6,    5,
    5,    4,    4,   56,   57,   48,   48,   48,   48,    2,
    2,    3,    3,   29,   29,   29,   29,   29,   27,   27,
   27,   28,   28,   28,   45,   45,   45,   45,   51,   51,
   51,   51,   26,   26,   26,   26,   52,   52,   52,   47,
   47,   58,   58,   59,   50,   50,   60,   60,   61,   62,
   36,   63,   63,   63,   65,   64,   67,   64,   69,   69,
   69,   69,   70,   70,   71,   72,   72,   72,   72,   72,
   73,   10,   10,   11,   11,   74,   75,   75,   75,   75,
   75,   75,   75,   68,   68,   68,    9,    9,   76,   66,
   66,   66,    8,    8,    8,    7,   77,   37,   78,   78,
   79,   79,   79,   79,   79,   79,   79,   20,   20,   18,
   18,   18,   17,   17,   17,   17,   17,   19,   23,   81,
   80,   80,   80,   82,   55,   55,   55,   83,   41,   84,
   84,   84,   24,   25,   40,   86,   38,   85,   85,   21,
   21,   22,   22,   22,   22,   22,   87,   87,   88,   88,
   88,   88,   88,   88,   88,   88,   88,   88,   88,   91,
   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
   88,   89,   89,   94,   94,   93,   93,   95,   95,   96,
   90,   90,   92,   92,   97,   97,   98,   39,   99,   99,
  100,  100,    1,   30,   30,
};
short yylen[] = {                                         2,
    1,    1,    2,    1,    2,    2,    2,    2,    2,    2,
    2,    2,    1,    2,    2,    3,    0,    5,    2,    3,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    3,    2,    2,    5,    2,    0,
    5,    2,    2,    4,    4,    4,    4,    0,    5,    4,
    4,    1,    1,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    4,    2,    2,    1,    4,
    2,    3,    0,    8,   10,   12,    8,    1,    2,    3,
    0,    2,    0,    2,    0,    2,    5,    1,    1,    1,
    1,    1,    1,    2,    2,    1,    1,    2,    2,    0,
    2,    0,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    2,    1,    1,    1,    1,    2,    2,    2,    0,
    1,    2,    3,    1,    0,    1,    2,    3,    1,    0,
    5,    2,    3,    1,    0,    6,    0,    6,    1,    1,
    2,    1,    2,    2,    2,    0,    1,    1,    2,    2,
    3,    1,    1,    0,    1,    2,    1,    1,    1,    2,
    2,    2,    2,    2,    3,    1,    1,    1,    1,    2,
    3,    1,    1,    1,    1,    1,    0,    6,    2,    3,
    2,    2,    2,    2,    4,    2,    1,    2,    3,    1,
    2,    2,    1,    3,    3,    1,    3,    1,    1,    1,
    2,    3,    1,    1,    2,    3,    1,    0,    6,    2,
    2,    1,    3,    3,    5,    0,    5,    0,    3,    0,
    1,    1,    1,    1,    1,    1,    2,    3,    2,    2,
    2,    2,    5,    2,    2,    4,    4,    4,    2,    0,
    5,    2,    2,    2,    2,    2,    5,    5,    4,    2,
    1,    2,    3,    1,    3,    0,    1,    2,    3,    1,
    1,    1,    0,    1,    2,    3,    1,    4,    2,    3,
    5,    5,    1,    1,    1,
};
short yydefred[] = {                                      0,
    0,   13,    0,   17,    0,  150,    0,    0,    0,    0,
  228,    0,    0,    2,    4,    0,    0,    0,    0,    0,
    0,    0,    0,   14,   15,    0,    0,    0,    0,  197,
    0,    0,  294,  295,    0,    0,    3,    5,    6,    7,
    8,    9,   10,   11,   12,   16,    0,   88,    0,    0,
    0,    0,    0,    0,  236,  241,    0,    0,    0,    0,
    0,   79,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   58,    0,    0,    0,    0,    0,    0,    0,
   50,    0,    0,   62,   63,  100,  101,    0,    0,   80,
    0,   81,  154,    0,    0,    0,    0,    0,    0,    0,
    0,  288,    0,  289,    0,    0,    0,    0,    0,  210,
    0,  216,    0,  218,    0,   24,   26,   25,   29,   27,
   28,  118,  114,  115,  116,  117,   31,   32,   33,   34,
   30,    0,    0,   52,    0,    0,    0,    0,    0,  134,
  135,  136,  129,  133,  130,  131,  132,   23,   22,   38,
   70,   39,  137,  138,  139,   98,   99,   64,   65,   66,
   35,   36,   37,   43,   44,   40,   41,   67,   68,   69,
   71,   74,   46,   72,   42,   47,   73,   78,   77,    0,
    0,   53,    0,   75,    0,    0,    0,    0,  119,  120,
  121,    0,  125,  126,  127,  128,   49,    0,   18,    0,
   19,    0,    0,    0,   82,  194,  195,  155,  196,  193,
  188,  157,  187,  151,    0,  152,  207,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  237,    0,    0,  290,
    0,    0,  212,    0,  211,  208,  235,    0,  232,    0,
    0,    0,    0,    0,  293,  103,  102,  105,  104,  108,
  109,  111,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  122,  123,  124,   45,    0,   20,
    0,    0,    0,    0,    0,  153,  204,  201,  203,    0,
  202,  206,  198,    0,  199,  271,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  260,    0,    0,    0,    0,  214,
  215,  217,  209,    0,    0,  230,  231,  229,    0,   92,
    0,    0,   76,    0,   89,   57,   61,  149,    0,    0,
    0,   54,   56,   55,   60,  144,    0,    0,    0,    0,
    0,    0,    0,    0,  223,  220,  219,    0,    0,  200,
  262,  264,  265,  266,  263,  250,  242,  243,  245,  244,
  246,  249,    0,    0,  254,    0,    0,    0,  270,  251,
  252,    0,    0,    0,  255,  281,  282,  259,    0,  239,
    0,  247,  291,  292,  233,  234,   48,   94,    0,    0,
   90,   59,    0,  147,   51,    0,  142,    0,    0,    0,
  192,  189,    0,    0,  186,    0,    0,    0,  179,    0,
    0,    0,    0,  177,  178,    0,  205,    0,  221,  113,
    0,    0,    0,  280,    0,    0,    0,    0,    0,    0,
    0,  248,   96,    0,  148,  143,    0,    0,    0,  156,
    0,  190,  162,    0,  159,  180,    0,  173,  175,  176,
  172,  181,  182,  183,  158,    0,  184,  222,    0,    0,
    0,    0,    0,  269,    0,  278,  256,  257,  258,  287,
    0,    0,    0,   97,    0,    0,   87,  191,  161,    0,
    0,    0,    0,  171,  185,    0,  253,    0,  272,  267,
  268,  279,  261,    0,  285,    0,  227,  224,    0,    0,
  163,  164,  165,  169,  170,  275,  273,  286,    0,   85,
    0,  225,    0,  226,   86,
};
short yydgoto[] = {                                      12,
  287,  178,  404,  288,  128,  198,  248,  249,  442,  489,
  490,  295,  362,  430,  296,  297,  150,  151,  152,  153,
   55,  402,  538,  282,  283,  183,  232,  308,  167,  154,
   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
   23,   27,  122,  123,  237,  238,  377,  174,  223,  369,
  124,  125,   51,   52,  539,  175,  176,  378,  379,  370,
  371,   29,  136,  137,  314,  443,  315,  453,  486,  522,
  523,  524,  454,  455,  456,  444,   54,  264,  265,  388,
  389,  540,   36,  284,  267,  139,  346,  347,  500,  418,
  419,  511,  465,  501,  466,  467,  512,  513,   58,   59,
};
short yysindex[] = {                                    199,
 -162,    0, -222,    0,  -72,    0, -199, -200,  -41,  -52,
    0,    0,  199,    0,    0, -179, -173, -153, -151, -149,
 -142, -125, -116,    0,    0, -114,   23, -193,   26,    0,
  -52, -121,    0,    0,   32,  -52,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  434,    0,  -30, -104,
 -111,  -97, -183,   39,    0,    0,  -64, -109,  -91,   69,
   47,    0,  -82,  -68,  -62,  -51,  -49,  -47,   34,   34,
   34,   34,  -44,   16,   -9,  103, -172, -172, -172, -172,
  -15,   -7,   34,   24,   34,   49,   62,   67, -118,   72,
   76, -185,   34,   34,   34,   34,   34,   84,   96,  102,
 -172,  109,   34,  110,   34,   34,  112,  113,   34,  254,
  256,  -30,    0,   34,  257,  258,  259,  260, -223,  -70,
    0,  314,  127,    0,    0,    0,    0, -180,  101,    0,
  132,    0,    0,  -42, -206,  -69,  133, -220,  270,  142,
  149,    0,  156,    0,  368,  370,  159,   69,  -58,    0,
  164,    0,  -29,    0, -194,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -32,  -30,    0,  150,  148,  171,  308,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   69,
   69,    0,  309,    0,   69,   69,   69,   69,    0,    0,
    0,   -6,    0,    0,    0,    0,    0,  312,    0,  180,
    0,  171,  318,  187,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  186,    0,    0, -118,   34,  188,
  333,   34,   34,  -92,  203,  459,    0,  205,  207,    0,
  208,  209,    0,  -24,    0,    0,    0,  214,    0,  -52,
  -52,   94,   98,  348,    0,    0,    0,    0,    0,    0,
    0,    0,   69,  -52,  118, -106,  219,  -20,  -16,  220,
  -11,   15,   19,   27,    0,    0,    0,    0,  221,    0,
  190,   69,  193,  359,  361,    0,    0,    0,    0,   97,
    0,    0,    0,  228,    0,    0,  227,    8,   34, -172,
  226,  -13,  210,  -30,    6,  366,   34,  229,  230,  369,
  371,  372,   -6,  -45,    0,   86,  236,  237,  238,    0,
    0,    0,    0,  240,  243,    0,    0,    0,   31,    0,
  -52,  225,    0,  244,    0,    0,    0,    0,  377,  220,
  251,    0,    0,    0,    0,    0,  384,  221,  253,  390,
   38,  255, -203, -221,    0,    0,    0, -102,  261,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  171,  392,    0,  262,  263,  265,    0,    0,
    0,   69,   69,   69,    0,    0,    0,    0,  394,    0,
  267,    0,    0,    0,    0,    0,    0,    0,  264,  239,
    0,    0,  269,    0,    0,  273,    0,   69,  170,  242,
    0,    0,  -79,  275,    0,   21,  266, -184,    0,   34,
   34,   34, -117,    0,    0,  276,    0,  277,    0,    0,
  278,  279,  281,    0,  410,  265,  280,   42,   46,   53,
  283,    0,    0,  282,    0,    0,   64,  422,  287,    0,
  290,    0,    0,  289,    0,    0,   14,    0,    0,    0,
    0,    0,    0,    0,    0,  292,    0,    0,  174,  -78,
  295,  293,  294,    0,  296,    0,    0,    0,    0,    0,
  431,  283,  300,    0,  211,  106,    0,    0,    0, -214,
 -172,  222,  224,    0,    0,  -52,    0,  304,    0,    0,
    0,    0,    0,  305,    0,  440,    0,    0,  -88,  307,
    0,    0,    0,    0,    0,    0,    0,    0,  106,    0,
  310,    0,  -75,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  315,    0,    0,
  -89,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  316,    0,    0,    0,
  315,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  443,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  316,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  317,    0,
    0,    0,    0,    0,  319,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  320,  321,    0,    0, -239,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   82, -239,    0,    0,    0,  446,
    0,    0,    0,    0,    0,    0,    0,    0,  467,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  470,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  322,    0,    0,    0,    0,    0,    0,    0,  474,
    0,    0,    0,    0,    0,    0,    0,  475,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  476,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  338,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  477,    0,    0,    0,    0,
  479,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  351,    0,    0,  352,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  386,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  498,    0,    0,  387,    0,    0,    0,    0,    0,
    0,  388,  389,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
 -152,    0,    0,    0, -101,  367,    0,    0,  512,    0,
    0,    0,    0,    0,    0,  353,  499,   35,    0,  184,
    0,    0, -305,  373,  378,  -77,    0,  311,  -65,  -10,
    0,  637,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  529,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  601,  104,  483,  480,    0,  284,    0,
  291,    0,    0,  527,    0,    0,    0,    0,    0,  141,
  143,    0,    0,    0,  213,  231,    0,    0,  403,    0,
  285, -473,    0,    0,    0,    0,    0,  323,    0,    0,
    0,    0,    0,  168,    0,  204,    0,  160,    0,  613,
};
#define YYTABLESIZE 843
short yytable[] = {                                      35,
  185,  186,  187,  149,  168,  169,  170,  495,  149,  286,
  222,  127,  149,  130,  386,  142,  149,  190,  363,  192,
   56,  149,  457,  211,  292,   61,  202,  203,  204,  205,
  206,  207,  323,  240,  445,  257,  550,  213,   26,  215,
  216,   91,   91,  219,  541,  480,  527,  149,  224,  555,
   28,  149,  441,   33,   34,  254,   33,   34,   30,  149,
   31,  279,   48,  149,  148,  551,  184,  184,  184,  184,
  149,  289,  133,  162,  149,   33,   34,   38,  149,  551,
  542,   32,  386,   39,  258,  149,  180,   33,   34,  311,
  184,   49,   50,  148,   24,  277,  149,  242,  148,   25,
  352,  149,  148,   40,  366,   41,  148,   42,  367,  243,
  446,  148,  447,  372,   43,  448,   91,  449,  450,  451,
  452,  181,  182,  250,  253,  201,  259,  260,  261,  262,
  263,   44,  251,  229,  230,  251,  231,  148,   57,  373,
   45,  148,   46,  374,   48,   47,  134,  135,   53,  148,
   57,  375,  488,  148,   60,  427,  129,   33,   34,  132,
  148,  138,  439,  257,  148,  144,  507,  240,  148,  155,
  508,   33,   34,   49,   50,  148,  294,  509,  156,  499,
   33,   34,  280,  281,   33,   34,  148,  278,  515,  196,
  197,  148,  157,  318,  140,  141,  321,  322,  158,  145,
  146,   33,   34,  163,  164,  165,  166,   33,   34,  159,
  420,  160,  258,  161,  446,  171,  447,   33,   34,  448,
  546,  449,  450,  451,  452,  179,  285,  126,  145,  146,
   33,   34,  405,  145,  146,   33,   34,  145,  146,   33,
   34,  145,  146,   33,   34,  188,  145,  146,   33,   34,
  460,  246,  395,  189,  259,  260,  261,  262,  263,  251,
  134,  135,  393,  394,  406,  407,  162,  247,  177,  354,
  355,  409,  145,  146,   33,   34,  145,  146,   33,   34,
   33,   34,  191,  360,  145,  146,   33,   34,  145,  146,
   33,   34,  162,  172,  173,  145,  146,   33,   34,  145,
  146,   33,   34,  145,  146,   33,   34,  193,  278,  387,
  145,  146,   33,   34,  233,  234,  235,  236,  392,  184,
  194,  145,  146,   33,   34,  195,  145,  146,   33,   34,
  199,  274,  278,  278,  200,  278,  278,  278,  278,  416,
  417,  326,  208,  397,  398,  399,  147,  400,  520,  521,
  428,  147,  385,  483,  209,  147,   33,   34,  484,  147,
  210,  537,   93,   93,  147,   33,   34,  212,  214,  401,
  217,  218,  253,  305,  306,  307,  220,  387,  221,  225,
  226,  227,  228,  241,  492,  493,  494,  244,  245,  256,
  147,  327,  266,  278,  147,  328,  163,  164,  165,  166,
  268,  329,  147,  298,  299,  330,  147,  269,  301,  302,
  303,  304,  270,  147,  271,  278,  272,  147,  273,  331,
  276,  147,  163,  164,  165,  166,  173,  172,  147,  285,
  293,  300,  253,  294,  309,  485,  310,  491,  239,  147,
  312,  332,  316,  543,  147,  313,  319,  333,  334,  335,
  336,  337,  338,  339,    1,  320,  340,  341,  342,  325,
    2,    3,    4,  348,  343,  349,  350,  351,  344,  345,
  353,  281,  358,  361,  280,  365,  359,  368,  376,  380,
  382,  383,    5,  384,  390,  391,  396,  403,  408,  410,
  411,  412,  422,  413,  414,  381,  425,  423,  424,  426,
  431,  432,  278,  278,  278,  387,  429,  434,  435,  437,
  184,  278,  438,  440,  461,  387,  471,  459,  478,  474,
  462,  463,  464,  472,  473,  475,  487,    6,  387,  476,
  479,  482,  497,  498,  504,  499,  506,  502,  387,  503,
  510,  514,  387,    7,  516,  517,  518,  519,  525,  526,
    8,  529,  532,  530,  531,  533,  535,  521,  520,  536,
  547,  548,  549,  552,    1,  110,  554,    9,   10,   62,
  145,   83,   21,  238,   11,  213,  106,  107,   63,   64,
   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
   75,  140,  112,   76,  174,  468,  469,  470,  146,  141,
  276,  277,   95,  283,   77,   78,   79,  160,  166,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,  477,  284,   92,  317,   93,   94,   95,   96,   97,
   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
  108,  109,  274,   84,  167,  168,  252,  275,  364,   37,
  240,  131,  553,  415,  290,  357,  110,  111,  291,  356,
  433,  436,  255,  545,  544,  496,  324,  528,  421,  505,
  143,  534,  458,  481,    0,    0,  112,    0,  113,  114,
    0,    0,    0,    0,    0,  115,  116,  117,  118,   62,
    0,    0,  119,    0,    0,    0,  120,  121,   63,   64,
   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
   75,    0,    0,   76,  326,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   77,   78,   79,    0,    0,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,    0,    0,   92,    0,   93,   94,   95,   96,   97,
   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
  108,  109,    0,    0,  327,    0,    0,    0,  328,    0,
    0,    0,    0,    0,  329,    0,  110,  111,  330,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  331,    0,    0,    0,  112,    0,  113,  114,
    0,    0,    0,    0,    0,  115,  116,  117,  118,    0,
    0,    0,  119,    0,  332,    0,  120,  121,    0,    0,
  333,  334,  335,  336,  337,  338,  339,    0,    0,  340,
  341,  342,    0,    0,    0,    0,    0,  343,    0,    0,
    0,  344,  345,
};
short yycheck[] = {                                      10,
   78,   79,   80,   33,   70,   71,   72,  125,   33,   42,
  112,   42,   33,  125,  320,  125,   33,   83,  125,   85,
   31,   33,  125,  101,  177,   36,   92,   93,   94,   95,
   96,   97,  125,  123,  256,  256,  125,  103,  261,  105,
  106,  281,  282,  109,  259,  125,  125,   33,  114,  125,
  123,   33,  256,  260,  261,  125,  260,  261,  258,   33,
  261,  256,  256,   33,  123,  539,   77,   78,   79,   80,
   33,  173,  256,  259,   33,  260,  261,  257,   33,  553,
  295,  123,  388,  257,  305,   33,  259,  260,  261,  242,
  101,  285,  286,  123,  257,  125,   33,  278,  123,  262,
  125,   33,  123,  257,  125,  257,  123,  257,  125,  290,
  332,  123,  334,  125,  257,  337,  356,  339,  340,  341,
  342,  294,  295,  134,  135,  311,  347,  348,  349,  350,
  351,  257,  339,  357,  358,  339,  360,  123,  260,  125,
  257,  123,  257,  125,  256,  123,  330,  331,  123,  123,
  260,  125,  337,  123,  123,  125,  261,  260,  261,  257,
  123,  123,  125,  256,  123,  257,  125,  257,  123,  123,
  125,  260,  261,  285,  286,  123,  283,  125,  261,  258,
  260,  261,  377,  378,  260,  261,  123,  153,  125,  308,
  309,  123,  261,  259,  259,  260,  262,  263,  261,  258,
  259,  260,  261,  389,  390,  391,  392,  260,  261,  261,
  125,  261,  305,  261,  332,  260,  334,  260,  261,  337,
  526,  339,  340,  341,  342,  123,  259,  258,  258,  259,
  260,  261,  334,  258,  259,  260,  261,  258,  259,  260,
  261,  258,  259,  260,  261,  261,  258,  259,  260,  261,
  403,  294,  330,  261,  347,  348,  349,  350,  351,  339,
  330,  331,  328,  329,  259,  260,  259,  310,  278,  280,
  281,  337,  258,  259,  260,  261,  258,  259,  260,  261,
  260,  261,  259,  294,  258,  259,  260,  261,  258,  259,
  260,  261,  259,  278,  279,  258,  259,  260,  261,  258,
  259,  260,  261,  258,  259,  260,  261,  259,  274,  320,
  258,  259,  260,  261,  385,  386,  387,  388,  311,  330,
  259,  258,  259,  260,  261,  259,  258,  259,  260,  261,
  259,  148,  298,  299,  259,  301,  302,  303,  304,  385,
  386,  256,  259,  357,  358,  359,  376,  361,  335,  336,
  361,  376,  256,  333,  259,  376,  260,  261,  338,  376,
  259,  256,  281,  282,  376,  260,  261,  259,  259,  383,
  259,  259,  383,  380,  381,  382,  123,  388,  123,  123,
  123,  123,  123,  257,  450,  451,  452,  287,  257,  257,
  376,  306,  123,  359,  376,  310,  389,  390,  391,  392,
  259,  316,  376,  220,  221,  320,  376,  259,  225,  226,
  227,  228,  257,  376,   47,  381,   47,  376,  260,  334,
  257,  376,  389,  390,  391,  392,  279,  278,  376,  259,
  123,  123,  443,  283,  123,  446,  257,  448,  125,  376,
  123,  356,  257,  521,  376,  259,  259,  362,  363,  364,
  365,  366,  367,  368,  256,  123,  371,  372,  373,  257,
  262,  263,  264,  259,  379,  259,  259,  259,  383,  384,
  257,  378,  125,  356,  377,  257,  293,  258,  258,  290,
  288,  123,  284,  123,  257,  259,  261,  278,  123,  261,
  261,  123,  257,  123,  123,  312,  257,  261,  261,  257,
  257,  125,  468,  469,  470,  516,  282,  257,  125,  257,
  521,  477,  123,  259,  123,  526,  123,  257,  349,  281,
  259,  259,  258,  257,  261,  257,  261,  329,  539,  257,
  289,  257,  257,  257,  125,  258,  257,  259,  549,  259,
  258,  260,  553,  345,  123,  259,  257,  259,  257,  376,
  352,  257,  257,  261,  261,  125,  257,  336,  335,  349,
  257,  257,  123,  257,    0,  123,  257,  369,  370,  256,
  125,  257,  257,  257,  376,  257,  257,  257,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  125,  123,  280,  257,  412,  413,  414,  125,  125,
  125,  125,  281,  125,  291,  292,  293,  257,  257,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  438,  125,  310,  258,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  257,  257,  257,  257,  135,  149,  296,   13,
  122,   51,  549,  343,  175,  283,  343,  344,  176,  282,
  370,  378,  136,  523,  522,  453,  264,  500,  346,  466,
   58,  512,  388,  443,   -1,   -1,  363,   -1,  365,  366,
   -1,   -1,   -1,   -1,   -1,  372,  373,  374,  375,  256,
   -1,   -1,  379,   -1,   -1,   -1,  383,  384,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,   -1,   -1,  280,  256,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  291,  292,  293,   -1,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,   -1,   -1,  310,   -1,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,   -1,   -1,  306,   -1,   -1,   -1,  310,   -1,
   -1,   -1,   -1,   -1,  316,   -1,  343,  344,  320,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  334,   -1,   -1,   -1,  363,   -1,  365,  366,
   -1,   -1,   -1,   -1,   -1,  372,  373,  374,  375,   -1,
   -1,   -1,  379,   -1,  356,   -1,  383,  384,   -1,   -1,
  362,  363,  364,  365,  366,  367,  368,   -1,   -1,  371,
  372,  373,   -1,   -1,   -1,   -1,   -1,  379,   -1,   -1,
   -1,  383,  384,
};
#define YYFINAL 12
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 392
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,0,0,0,0,"'*'",0,0,0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"L_EOS",
"L_IPADDR","L_NUMBER","L_STRING","L_QSTRING","L_END_INCLUDE","T_INCLUDE",
"T_OPTIONS","T_DIRECTORY","T_PIDFILE","T_NAMED_XFER","T_DUMP_FILE",
"T_STATS_FILE","T_MEMSTATS_FILE","T_FAKE_IQUERY","T_RECURSION","T_FETCH_GLUE",
"T_HITCOUNT","T_PREFERRED_GLUE","T_QUERY_SOURCE","T_LISTEN_ON","T_PORT",
"T_ADDRESS","T_RRSET_ORDER","T_ORDER","T_NAME","T_CLASS","T_CONTROLS","T_INET",
"T_UNIX","T_PERM","T_OWNER","T_GROUP","T_ALLOW","T_DATASIZE","T_STACKSIZE",
"T_CORESIZE","T_DEFAULT","T_UNLIMITED","T_FILES","T_VERSION","T_HOSTNAME",
"T_HOSTSTATS","T_HOSTSTATSMAX","T_DEALLOC_ON_EXIT","T_TRANSFERS_IN",
"T_TRANSFERS_OUT","T_TRANSFERS_PER_NS","T_TRANSFER_FORMAT",
"T_MAX_TRANSFER_TIME_IN","T_SERIAL_QUERIES","T_ONE_ANSWER","T_MANY_ANSWERS",
"T_NOTIFY","T_EXPLICIT","T_NOTIFY_INITIAL","T_AUTH_NXDOMAIN",
"T_MULTIPLE_CNAMES","T_USE_IXFR","T_MAINTAIN_IXFR_BASE","T_CLEAN_INTERVAL",
"T_INTERFACE_INTERVAL","T_STATS_INTERVAL","T_MAX_LOG_SIZE_IXFR","T_HEARTBEAT",
"T_USE_ID_POOL","T_MAX_NCACHE_TTL","T_HAS_OLD_CLIENTS","T_RFC2308_TYPE1",
"T_LAME_TTL","T_MIN_ROOTS","T_TREAT_CR_AS_SPACE","T_LOGGING","T_CATEGORY",
"T_CHANNEL","T_SEVERITY","T_DYNAMIC","T_FILE","T_VERSIONS","T_SIZE","T_SYSLOG",
"T_DEBUG","T_NULL_OUTPUT","T_PRINT_TIME","T_PRINT_CATEGORY","T_PRINT_SEVERITY",
"T_SORTLIST","T_TOPOLOGY","T_SERVER","T_LONG_AXFR","T_BOGUS","T_TRANSFERS",
"T_KEYS","T_SUPPORT_IXFR","T_EDNS","T_ZONE","T_IN","T_CHAOS","T_HESIOD",
"T_TYPE","T_MASTER","T_SLAVE","T_STUB","T_RESPONSE","T_HINT","T_MASTERS",
"T_TRANSFER_SOURCE","T_PUBKEY","T_ALSO_NOTIFY","T_DIALUP","T_FILE_IXFR",
"T_IXFR_TMP","T_TRUSTED_KEYS","T_ACL","T_ALLOW_UPDATE","T_ALLOW_QUERY",
"T_ALLOW_TRANSFER","T_ALLOW_RECURSION","T_BLACKHOLE","T_SEC_KEY","T_ALGID",
"T_SECRET","T_CHECK_NAMES","T_WARN","T_FAIL","T_IGNORE","T_FORWARD",
"T_FORWARDERS","T_ONLY","T_FIRST","T_IF_NO_ANSWER","T_IF_NO_DOMAIN","T_YES",
"T_TRUE","T_NO","T_FALSE",
};
char *yyrule[] = {
"$accept : config_file",
"config_file : statement_list",
"statement_list : statement",
"statement_list : statement_list statement",
"statement : include_stmt",
"statement : options_stmt L_EOS",
"statement : controls_stmt L_EOS",
"statement : logging_stmt L_EOS",
"statement : server_stmt L_EOS",
"statement : zone_stmt L_EOS",
"statement : trusted_keys_stmt L_EOS",
"statement : acl_stmt L_EOS",
"statement : key_stmt L_EOS",
"statement : L_END_INCLUDE",
"statement : error L_EOS",
"statement : error L_END_INCLUDE",
"include_stmt : T_INCLUDE L_QSTRING L_EOS",
"$$1 :",
"options_stmt : T_OPTIONS $$1 '{' options '}'",
"options : option L_EOS",
"options : options option L_EOS",
"option :",
"option : T_HOSTNAME L_QSTRING",
"option : T_VERSION L_QSTRING",
"option : T_DIRECTORY L_QSTRING",
"option : T_NAMED_XFER L_QSTRING",
"option : T_PIDFILE L_QSTRING",
"option : T_STATS_FILE L_QSTRING",
"option : T_MEMSTATS_FILE L_QSTRING",
"option : T_DUMP_FILE L_QSTRING",
"option : T_PREFERRED_GLUE L_STRING",
"option : T_FAKE_IQUERY yea_or_nay",
"option : T_RECURSION yea_or_nay",
"option : T_FETCH_GLUE yea_or_nay",
"option : T_HITCOUNT yea_or_nay",
"option : T_NOTIFY T_EXPLICIT",
"option : T_NOTIFY yea_or_nay",
"option : T_NOTIFY_INITIAL yea_or_nay",
"option : T_HOSTSTATS yea_or_nay",
"option : T_DEALLOC_ON_EXIT yea_or_nay",
"option : T_USE_IXFR yea_or_nay",
"option : T_MAINTAIN_IXFR_BASE yea_or_nay",
"option : T_HAS_OLD_CLIENTS yea_or_nay",
"option : T_AUTH_NXDOMAIN yea_or_nay",
"option : T_MULTIPLE_CNAMES yea_or_nay",
"option : T_CHECK_NAMES check_names_type check_names_opt",
"option : T_USE_ID_POOL yea_or_nay",
"option : T_RFC2308_TYPE1 yea_or_nay",
"option : T_LISTEN_ON maybe_port '{' address_match_list '}'",
"option : T_FORWARD forward_opt",
"$$2 :",
"option : T_FORWARDERS $$2 '{' opt_forwarders_list '}'",
"option : T_QUERY_SOURCE query_source",
"option : T_TRANSFER_SOURCE maybe_wild_addr",
"option : T_ALLOW_QUERY '{' address_match_list '}'",
"option : T_ALLOW_RECURSION '{' address_match_list '}'",
"option : T_ALLOW_TRANSFER '{' address_match_list '}'",
"option : T_SORTLIST '{' address_match_list '}'",
"$$3 :",
"option : T_ALSO_NOTIFY $$3 '{' opt_also_notify_list '}'",
"option : T_BLACKHOLE '{' address_match_list '}'",
"option : T_TOPOLOGY '{' address_match_list '}'",
"option : size_clause",
"option : transfer_clause",
"option : T_TRANSFER_FORMAT transfer_format",
"option : T_MAX_TRANSFER_TIME_IN L_NUMBER",
"option : T_SERIAL_QUERIES L_NUMBER",
"option : T_CLEAN_INTERVAL L_NUMBER",
"option : T_INTERFACE_INTERVAL L_NUMBER",
"option : T_STATS_INTERVAL L_NUMBER",
"option : T_HOSTSTATSMAX L_NUMBER",
"option : T_MAX_LOG_SIZE_IXFR size_spec",
"option : T_MAX_NCACHE_TTL L_NUMBER",
"option : T_LAME_TTL L_NUMBER",
"option : T_HEARTBEAT L_NUMBER",
"option : T_DIALUP yea_or_nay",
"option : T_RRSET_ORDER '{' rrset_ordering_list '}'",
"option : T_TREAT_CR_AS_SPACE yea_or_nay",
"option : T_MIN_ROOTS L_NUMBER",
"option : error",
"controls_stmt : T_CONTROLS '{' controls '}'",
"controls : control L_EOS",
"controls : controls control L_EOS",
"control :",
"control : T_INET maybe_wild_addr T_PORT in_port T_ALLOW '{' address_match_list '}'",
"control : T_INET maybe_wild_addr T_ALLOW '{' address_match_list '}' T_KEYS '{' dummy_key_list '}'",
"control : T_INET maybe_wild_addr T_PORT in_port T_ALLOW '{' address_match_list '}' T_KEYS '{' dummy_key_list '}'",
"control : T_UNIX L_QSTRING T_PERM L_NUMBER T_OWNER L_NUMBER T_GROUP L_NUMBER",
"control : error",
"rrset_ordering_list : rrset_ordering_element L_EOS",
"rrset_ordering_list : rrset_ordering_list rrset_ordering_element L_EOS",
"ordering_class :",
"ordering_class : T_CLASS any_string",
"ordering_type :",
"ordering_type : T_TYPE any_string",
"ordering_name :",
"ordering_name : T_NAME L_QSTRING",
"rrset_ordering_element : ordering_class ordering_type ordering_name T_ORDER L_STRING",
"transfer_format : T_ONE_ANSWER",
"transfer_format : T_MANY_ANSWERS",
"maybe_wild_addr : L_IPADDR",
"maybe_wild_addr : '*'",
"maybe_wild_port : in_port",
"maybe_wild_port : '*'",
"query_source_address : T_ADDRESS maybe_wild_addr",
"query_source_port : T_PORT maybe_wild_port",
"query_source : query_source_address",
"query_source : query_source_port",
"query_source : query_source_address query_source_port",
"query_source : query_source_port query_source_address",
"maybe_port :",
"maybe_port : T_PORT in_port",
"maybe_zero_port :",
"maybe_zero_port : T_PORT in_port",
"yea_or_nay : T_YES",
"yea_or_nay : T_TRUE",
"yea_or_nay : T_NO",
"yea_or_nay : T_FALSE",
"yea_or_nay : L_NUMBER",
"check_names_type : T_MASTER",
"check_names_type : T_SLAVE",
"check_names_type : T_RESPONSE",
"check_names_opt : T_WARN",
"check_names_opt : T_FAIL",
"check_names_opt : T_IGNORE",
"forward_opt : T_ONLY",
"forward_opt : T_FIRST",
"forward_opt : T_IF_NO_ANSWER",
"forward_opt : T_IF_NO_DOMAIN",
"size_clause : T_DATASIZE size_spec",
"size_clause : T_STACKSIZE size_spec",
"size_clause : T_CORESIZE size_spec",
"size_clause : T_FILES size_spec",
"size_spec : any_string",
"size_spec : L_NUMBER",
"size_spec : T_DEFAULT",
"size_spec : T_UNLIMITED",
"transfer_clause : T_TRANSFERS_IN L_NUMBER",
"transfer_clause : T_TRANSFERS_OUT L_NUMBER",
"transfer_clause : T_TRANSFERS_PER_NS L_NUMBER",
"opt_forwarders_list :",
"opt_forwarders_list : forwarders_in_addr_list",
"forwarders_in_addr_list : forwarders_in_addr L_EOS",
"forwarders_in_addr_list : forwarders_in_addr_list forwarders_in_addr L_EOS",
"forwarders_in_addr : L_IPADDR",
"opt_also_notify_list :",
"opt_also_notify_list : also_notify_in_addr_list",
"also_notify_in_addr_list : also_notify_in_addr L_EOS",
"also_notify_in_addr_list : also_notify_in_addr_list also_notify_in_addr L_EOS",
"also_notify_in_addr : L_IPADDR",
"$$4 :",
"logging_stmt : T_LOGGING $$4 '{' logging_opts_list '}'",
"logging_opts_list : logging_opt L_EOS",
"logging_opts_list : logging_opts_list logging_opt L_EOS",
"logging_opts_list : error",
"$$5 :",
"logging_opt : T_CATEGORY category $$5 '{' channel_list '}'",
"$$6 :",
"logging_opt : T_CHANNEL channel_name $$6 '{' channel_opt_list '}'",
"channel_severity : any_string",
"channel_severity : T_DEBUG",
"channel_severity : T_DEBUG L_NUMBER",
"channel_severity : T_DYNAMIC",
"version_modifier : T_VERSIONS L_NUMBER",
"version_modifier : T_VERSIONS T_UNLIMITED",
"size_modifier : T_SIZE size_spec",
"maybe_file_modifiers :",
"maybe_file_modifiers : version_modifier",
"maybe_file_modifiers : size_modifier",
"maybe_file_modifiers : version_modifier size_modifier",
"maybe_file_modifiers : size_modifier version_modifier",
"channel_file : T_FILE L_QSTRING maybe_file_modifiers",
"facility_name : any_string",
"facility_name : T_SYSLOG",
"maybe_syslog_facility :",
"maybe_syslog_facility : facility_name",
"channel_syslog : T_SYSLOG maybe_syslog_facility",
"channel_opt : channel_file",
"channel_opt : channel_syslog",
"channel_opt : T_NULL_OUTPUT",
"channel_opt : T_SEVERITY channel_severity",
"channel_opt : T_PRINT_TIME yea_or_nay",
"channel_opt : T_PRINT_CATEGORY yea_or_nay",
"channel_opt : T_PRINT_SEVERITY yea_or_nay",
"channel_opt_list : channel_opt L_EOS",
"channel_opt_list : channel_opt_list channel_opt L_EOS",
"channel_opt_list : error",
"channel_name : any_string",
"channel_name : T_NULL_OUTPUT",
"channel : channel_name",
"channel_list : channel L_EOS",
"channel_list : channel_list channel L_EOS",
"channel_list : error",
"category_name : any_string",
"category_name : T_DEFAULT",
"category_name : T_NOTIFY",
"category : category_name",
"$$7 :",
"server_stmt : T_SERVER L_IPADDR $$7 '{' server_info_list '}'",
"server_info_list : server_info L_EOS",
"server_info_list : server_info_list server_info L_EOS",
"server_info : T_BOGUS yea_or_nay",
"server_info : T_SUPPORT_IXFR yea_or_nay",
"server_info : T_TRANSFERS L_NUMBER",
"server_info : T_TRANSFER_FORMAT transfer_format",
"server_info : T_KEYS '{' key_list '}'",
"server_info : T_EDNS yea_or_nay",
"server_info : error",
"address_match_list : address_match_element L_EOS",
"address_match_list : address_match_list address_match_element L_EOS",
"address_match_element : address_match_simple",
"address_match_element : '!' address_match_simple",
"address_match_element : T_SEC_KEY L_STRING",
"address_match_simple : L_IPADDR",
"address_match_simple : L_IPADDR '/' L_NUMBER",
"address_match_simple : L_NUMBER '/' L_NUMBER",
"address_match_simple : address_name",
"address_match_simple : '{' address_match_list '}'",
"address_name : any_string",
"key_ref : any_string",
"key_list_element : key_ref",
"key_list : key_list_element L_EOS",
"key_list : key_list key_list_element L_EOS",
"key_list : error",
"dummy_key_list_element : key_ref",
"dummy_key_list : dummy_key_list_element L_EOS",
"dummy_key_list : dummy_key_list dummy_key_list_element L_EOS",
"dummy_key_list : error",
"$$8 :",
"key_stmt : T_SEC_KEY $$8 any_string '{' key_definition '}'",
"key_definition : algorithm_id secret",
"key_definition : secret algorithm_id",
"key_definition : error",
"algorithm_id : T_ALGID any_string L_EOS",
"secret : T_SECRET any_string L_EOS",
"acl_stmt : T_ACL any_string '{' address_match_list '}'",
"$$9 :",
"zone_stmt : T_ZONE L_QSTRING optional_class $$9 optional_zone_options_list",
"optional_zone_options_list :",
"optional_zone_options_list : '{' zone_option_list '}'",
"optional_class :",
"optional_class : any_string",
"zone_type : T_MASTER",
"zone_type : T_SLAVE",
"zone_type : T_HINT",
"zone_type : T_STUB",
"zone_type : T_FORWARD",
"zone_option_list : zone_option L_EOS",
"zone_option_list : zone_option_list zone_option L_EOS",
"zone_option : T_TYPE zone_type",
"zone_option : T_FILE L_QSTRING",
"zone_option : T_FILE_IXFR L_QSTRING",
"zone_option : T_IXFR_TMP L_QSTRING",
"zone_option : T_MASTERS maybe_zero_port '{' master_in_addr_list '}'",
"zone_option : T_TRANSFER_SOURCE maybe_wild_addr",
"zone_option : T_CHECK_NAMES check_names_opt",
"zone_option : T_ALLOW_UPDATE '{' address_match_list '}'",
"zone_option : T_ALLOW_QUERY '{' address_match_list '}'",
"zone_option : T_ALLOW_TRANSFER '{' address_match_list '}'",
"zone_option : T_FORWARD zone_forward_opt",
"$$10 :",
"zone_option : T_FORWARDERS $$10 '{' opt_zone_forwarders_list '}'",
"zone_option : T_MAX_TRANSFER_TIME_IN L_NUMBER",
"zone_option : T_MAX_LOG_SIZE_IXFR size_spec",
"zone_option : T_NOTIFY T_EXPLICIT",
"zone_option : T_NOTIFY yea_or_nay",
"zone_option : T_MAINTAIN_IXFR_BASE yea_or_nay",
"zone_option : T_PUBKEY L_NUMBER L_NUMBER L_NUMBER L_QSTRING",
"zone_option : T_PUBKEY L_STRING L_NUMBER L_NUMBER L_QSTRING",
"zone_option : T_ALSO_NOTIFY '{' opt_notify_in_addr_list '}'",
"zone_option : T_DIALUP yea_or_nay",
"zone_option : error",
"master_in_addr_list : master_in_addr L_EOS",
"master_in_addr_list : master_in_addr_list master_in_addr L_EOS",
"master_in_addr : L_IPADDR",
"master_in_addr : L_IPADDR T_SEC_KEY key_ref",
"opt_notify_in_addr_list :",
"opt_notify_in_addr_list : notify_in_addr_list",
"notify_in_addr_list : notify_in_addr L_EOS",
"notify_in_addr_list : notify_in_addr_list notify_in_addr L_EOS",
"notify_in_addr : L_IPADDR",
"zone_forward_opt : T_ONLY",
"zone_forward_opt : T_FIRST",
"opt_zone_forwarders_list :",
"opt_zone_forwarders_list : zone_forwarders_in_addr_list",
"zone_forwarders_in_addr_list : zone_forwarders_in_addr L_EOS",
"zone_forwarders_in_addr_list : zone_forwarders_in_addr_list zone_forwarders_in_addr L_EOS",
"zone_forwarders_in_addr : L_IPADDR",
"trusted_keys_stmt : T_TRUSTED_KEYS '{' trusted_keys_list '}'",
"trusted_keys_list : trusted_key L_EOS",
"trusted_keys_list : trusted_keys_list trusted_key L_EOS",
"trusted_key : L_STRING L_NUMBER L_NUMBER L_NUMBER L_QSTRING",
"trusted_key : L_STRING L_STRING L_NUMBER L_NUMBER L_QSTRING",
"in_port : L_NUMBER",
"any_string : L_STRING",
"any_string : L_QSTRING",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
struct yystack {
    short *ssp;
    YYSTYPE *vsp;
    short *ss;
    YYSTYPE *vs;
    int stacksize;
    short *sslim;
};
int yychar; /* some people use this, so we copy it in & out */
int yyerrflag; /* must be global for yyerrok & YYRECOVERING */
YYSTYPE yylval;
#line 1862 "ns_parser.y"

static char *
canonical_name(char *name) {
	char canonical[MAXDNAME];
	
	if (strlen(name) >= MAXDNAME)
		return (NULL);
	strcpy(canonical, name);
	if (makename(canonical, ".", sizeof canonical) < 0)
		return (NULL);
	return (savestr(canonical, 0));
}

static void
init_acls() {
	ip_match_element ime;
	ip_match_list iml;
	struct in_addr address;

	/* Create the predefined ACLs */

	address.s_addr = 0U;

	/* ACL "any" */
	ime = new_ip_match_pattern(address, 0);
	iml = new_ip_match_list();
	add_to_ip_match_list(iml, ime);
	define_acl("any", iml);

	/* ACL "none" */
	ime = new_ip_match_pattern(address, 0);
	ip_match_negate(ime);
	iml = new_ip_match_list();
	add_to_ip_match_list(iml, ime);
	define_acl("none", iml);

	/* ACL "localhost" */
	ime = new_ip_match_localhost();
	iml = new_ip_match_list();
	add_to_ip_match_list(iml, ime);
	define_acl("localhost", iml);

	/* ACL "localnets" */
	ime = new_ip_match_localnets();
	iml = new_ip_match_list();
	add_to_ip_match_list(iml, ime);
	define_acl("localnets", iml);
}

static void
free_sym_value(int type, void *value) {
	ns_debug(ns_log_parser, 99, "free_sym_value: type %06x value %p",
		 type, value);
	type &= ~0xffff;
	switch (type) {
	case SYM_ACL:
		free_ip_match_list(value);
		break;
	case SYM_KEY:
		free_key_info(value);
		break;
	case SYM_CHANNEL:
		INSIST(log_free_channel(value) == 0);
		break;
	default:
		ns_panic(ns_log_parser, 1,
			 "unhandled case in free_sym_value()");
		/* NOTREACHED */
		break;
	}
}

static log_channel
lookup_channel(char *name) {
	symbol_value value;

	if (lookup_symbol(channeltab, name, SYM_CHANNEL, &value))
		return ((log_channel)(value.pointer));
	return (NULL);
}

static void
define_channel(const char *name, log_channel channel) {
	symbol_value value;

	value.pointer = channel;  
	INSIST(log_inc_references(channel) == 0);
	define_symbol(channeltab, name, SYM_CHANNEL, value, SYMBOL_FREE_VALUE);
}

static void
define_builtin_channels() {
	define_channel("default_syslog", syslog_channel);
	define_channel("default_debug", debug_channel);
	define_channel("default_stderr", stderr_channel);
	define_channel("null", null_channel);
}

static void
parser_setup() {
	seen_options = 0;
	logged_options_error = 0;
	seen_topology = 0;
	symtab = new_symbol_table(SYMBOL_TABLE_SIZE, NULL);
	if (authtab != NULL)
		free_symbol_table(authtab);
	authtab = new_symbol_table(AUTH_TABLE_SIZE, free_sym_value);
	if (channeltab != NULL)
		free_symbol_table(channeltab);
	channeltab = new_symbol_table(AUTH_TABLE_SIZE, free_sym_value);
	init_acls();
	define_builtin_channels();
	INIT_LIST(current_controls);
}

static void
parser_cleanup() {
	if (symtab != NULL)
		free_symbol_table(symtab);
	symtab = NULL;
	/*
	 * We don't clean up authtab here because the ip_match_lists are in
	 * use.
	 */
}

/*
 * Public Interface
 */

ip_match_list
lookup_acl(const char *name) {
	symbol_value value;

	if (lookup_symbol(authtab, name, SYM_ACL, &value))
		return ((ip_match_list)(value.pointer));
	return (NULL);
}

void
define_acl(const char *name, ip_match_list iml) {
	symbol_value value;

	INSIST(name != NULL);
	INSIST(iml != NULL);

	value.pointer = iml;
	define_symbol(authtab, name, SYM_ACL, value, SYMBOL_FREE_VALUE);
	ns_debug(ns_log_parser, 7, "acl %s", name);
	dprint_ip_match_list(ns_log_parser, iml, 2, "allow ", "deny ");
}

struct dst_key *
lookup_key(char *name) {
	symbol_value value;

	if (lookup_symbol(authtab, name, SYM_KEY, &value))
		return ((struct dst_key *)(value.pointer));
	return (NULL);
}

void
define_key(const char *name, struct dst_key *dst_key) {
	symbol_value value;

	INSIST(name != NULL);
	INSIST(dst_key != NULL);

	value.pointer = dst_key;
	define_symbol(authtab, name, SYM_KEY, value, SYMBOL_FREE_VALUE);
	dprint_key_info(dst_key);
}

time_t
parse_configuration(const char *filename) {
	FILE *config_stream;
	struct stat sb;

	config_stream = fopen(filename, "r");
	if (config_stream == NULL)
		ns_panic(ns_log_parser, 0, "can't open '%s'", filename);
	if (fstat(fileno(config_stream), &sb) == -1)
		ns_panic(ns_log_parser, 0, "can't stat '%s'", filename);

	lexer_setup();
	parser_setup();
	lexer_begin_file(filename, config_stream);
	(void)yyparse();
	lexer_end_file();
	parser_cleanup();
	return (sb.st_mtime);
}

void
parser_initialize(void) {
	lexer_initialize();
}

void
parser_shutdown(void) {
	if (authtab != NULL)
		free_symbol_table(authtab);
	if (channeltab != NULL)
		free_symbol_table(channeltab);
	lexer_shutdown();
}
#line 1279 "y.tab.c"
/* allocate initial stack */
#if defined(__STDC__) || defined(__cplusplus)
static int yyinitstack(struct yystack *sp)
#else
static int yyinitstack(sp)
    struct yystack *sp;
#endif
{
    int newsize;
    short *newss;
    YYSTYPE *newvs;

    newsize = YYINITSTACKSIZE;
    newss = (short *)malloc(newsize * sizeof *newss);
    newvs = (YYSTYPE *)malloc(newsize * sizeof *newvs);
    sp->ss = sp->ssp = newss;
    sp->vs = sp->vsp = newvs;
    if (newss == NULL || newvs == NULL) return -1;
    sp->stacksize = newsize;
    sp->sslim = newss + newsize - 1;
    return 0;
}

/* double stack size, up to YYMAXDEPTH */
#if defined(__STDC__) || defined(__cplusplus)
static int yygrowstack(struct yystack *sp)
#else
static int yygrowstack(sp)
    struct yystack *sp;
#endif
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = sp->stacksize) >= YYMAXDEPTH) return -1;
    if ((newsize *= 2) > YYMAXDEPTH) newsize = YYMAXDEPTH;
    i = sp->ssp - sp->ss;
    if ((newss = (short *)realloc(sp->ss, newsize * sizeof *newss)) == NULL)
        return -1;
    sp->ss = newss;
    sp->ssp = newss + i;
    if ((newvs = (YYSTYPE *)realloc(sp->vs, newsize * sizeof *newvs)) == NULL)
        return -1;
    sp->vs = newvs;
    sp->vsp = newvs + i;
    sp->stacksize = newsize;
    sp->sslim = newss + newsize - 1;
    return 0;
}

#define YYFREESTACK(sp) { free((sp)->ss); free((sp)->vs); }

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate, yych;
    register YYSTYPE *yyvsp;
    YYSTYPE yyval;
    struct yystack yystk;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = yych = YYEMPTY;

    if (yyinitstack(&yystk)) goto yyoverflow;
    *yystk.ssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yych < 0)
    {
        if ((yych = YYLEX) < 0) yych = 0;
        yychar = yych;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yych <= YYMAXTOKEN) yys = yyname[yych];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yych, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yych) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yych)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystk.ssp >= yystk.sslim && yygrowstack(&yystk))
            goto yyoverflow;
        *++yystk.ssp = yystate = yytable[yyn];
        *++yystk.vsp = yylval;
        yychar = yych = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yych) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yych)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystk.ssp]) &&
                    (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystk.ssp, yytable[yyn]);
#endif
                if (yystk.ssp >= yystk.sslim && yygrowstack(&yystk))
                    goto yyoverflow;
                *++yystk.ssp = yystate = yytable[yyn];
                *++yystk.vsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystk.ssp);
#endif
                if (yystk.ssp <= yystk.ss) goto yyabort;
                --yystk.ssp;
                --yystk.vsp;
            }
        }
    }
    else
    {
        if (yych == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yych <= YYMAXTOKEN) yys = yyname[yych];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yych, yys);
        }
#endif
        yychar = yych = YYEMPTY;
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyvsp = yystk.vsp; /* for speed in code under switch() */
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 247 "ns_parser.y"
{
		if (EMPTY(current_controls))
			ns_ctl_defaults(&current_controls);
		ns_ctl_install(&current_controls);
	}
break;
case 16:
#line 273 "ns_parser.y"
{
		lexer_begin_file(yyvsp[-1].cp, NULL);
		(void)freestr(yyvsp[-1].cp);
	}
break;
case 17:
#line 284 "ns_parser.y"
{
		if (seen_options)
			parser_error(0, "cannot redefine options");
		current_options = new_options();
	}
break;
case 18:
#line 290 "ns_parser.y"
{
		if (!seen_options)
			set_options(current_options, 0);
		else
			free_options(current_options);
		current_options = NULL;
		seen_options = 1;
	}
break;
case 22:
#line 306 "ns_parser.y"
{
		if (current_options->hostname != NULL)
			(void)freestr(current_options->hostname);
		current_options->hostname = yyvsp[0].cp;
	}
break;
case 23:
#line 312 "ns_parser.y"
{
		if (current_options->version != NULL)
			(void)freestr(current_options->version);
		current_options->version = yyvsp[0].cp;
	}
break;
case 24:
#line 318 "ns_parser.y"
{
		if (current_options->directory != NULL)
			(void)freestr(current_options->directory);
		current_options->directory = yyvsp[0].cp;
	}
break;
case 25:
#line 324 "ns_parser.y"
{
		if (current_options->named_xfer != NULL)
			(void)freestr(current_options->named_xfer);
		current_options->named_xfer = yyvsp[0].cp;
	}
break;
case 26:
#line 330 "ns_parser.y"
{
		if (current_options->pid_filename != NULL)
			(void)freestr(current_options->pid_filename);
		current_options->pid_filename = yyvsp[0].cp;
	}
break;
case 27:
#line 336 "ns_parser.y"
{
		if (current_options->stats_filename != NULL)
			(void)freestr(current_options->stats_filename);
		current_options->stats_filename = yyvsp[0].cp;
	}
break;
case 28:
#line 342 "ns_parser.y"
{
		if (current_options->memstats_filename != NULL)
			(void)freestr(current_options->memstats_filename);
		current_options->memstats_filename = yyvsp[0].cp;
	}
break;
case 29:
#line 348 "ns_parser.y"
{
		if (current_options->dump_filename != NULL)
			(void)freestr(current_options->dump_filename);
		current_options->dump_filename = yyvsp[0].cp;
	}
break;
case 30:
#line 354 "ns_parser.y"
{
		current_options->preferred_glue =
			strcasecmp(yyvsp[0].cp, "aaaa") ? T_A : T_AAAA;
	}
break;
case 31:
#line 359 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_FAKE_IQUERY, yyvsp[0].num);
	}
break;
case 32:
#line 364 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_NORECURSE, !yyvsp[0].num);
	}
break;
case 33:
#line 369 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_NOFETCHGLUE, !yyvsp[0].num);
	}
break;
case 34:
#line 374 "ns_parser.y"
{
		set_global_boolean_option(current_options, 
			OPTION_HITCOUNT, yyvsp[0].num);
	}
break;
case 35:
#line 379 "ns_parser.y"
{
		current_options->notify = notify_explicit;
	}
break;
case 36:
#line 383 "ns_parser.y"
{
		if (yyvsp[0].num)
			current_options->notify = notify_yes;
		else
			current_options->notify = notify_no;
	}
break;
case 37:
#line 390 "ns_parser.y"
{
		if (initial_configuration && yyvsp[0].num)
			ns_notice(ns_log_default,
				  "suppressing initial notifies");
		set_global_boolean_option(current_options, 
			OPTION_SUPNOTIFY_INITIAL, yyvsp[0].num);
	}
break;
case 38:
#line 398 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_HOSTSTATS, yyvsp[0].num);
	}
break;
case 39:
#line 403 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_DEALLOC_ON_EXIT, yyvsp[0].num);
	}
break;
case 40:
#line 408 "ns_parser.y"
{
		set_global_boolean_option(current_options, OPTION_USE_IXFR, yyvsp[0].num);
	}
break;
case 41:
#line 412 "ns_parser.y"
{
		set_global_boolean_option(current_options,
					  OPTION_MAINTAIN_IXFR_BASE, yyvsp[0].num);
	}
break;
case 42:
#line 417 "ns_parser.y"
{
		set_global_boolean_option(current_options,
					  OPTION_NORFC2308_TYPE1, yyvsp[0].num);
		set_global_boolean_option(current_options,
					  OPTION_NONAUTH_NXDOMAIN, !yyvsp[0].num);
	}
break;
case 43:
#line 424 "ns_parser.y"
{
		set_global_boolean_option(current_options, OPTION_NONAUTH_NXDOMAIN,
				   !yyvsp[0].num);
	}
break;
case 44:
#line 429 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_MULTIPLE_CNAMES, yyvsp[0].num);
	}
break;
case 45:
#line 434 "ns_parser.y"
{
		current_options->check_names[yyvsp[-1].s_int] = (enum severity)yyvsp[0].s_int;
	}
break;
case 46:
#line 438 "ns_parser.y"
{
		set_global_boolean_option(current_options,
					  OPTION_USE_ID_POOL, yyvsp[0].num);
	}
break;
case 47:
#line 443 "ns_parser.y"
{
		set_global_boolean_option(current_options,
                        		  OPTION_NORFC2308_TYPE1, !yyvsp[0].num);
	}
break;
case 48:
#line 448 "ns_parser.y"
{
		char port_string[10];
		symbol_value value;

		(void)sprintf(port_string, "%u", yyvsp[-3].us_int);
		if (lookup_symbol(symtab, port_string, SYM_PORT, NULL))
			parser_error(0,
				     "cannot redefine listen-on for port %u",
				     ntohs(yyvsp[-3].us_int));
		else {
			add_listen_on(current_options, yyvsp[-3].us_int, yyvsp[-1].iml);
			value.pointer = NULL;
			define_symbol(symtab, port_string, SYM_PORT, value, 0);
		}

	}
break;
case 50:
#line 466 "ns_parser.y"
{
		if (current_options->fwdtab) {
			free_forwarders(current_options->fwdtab);
			current_options->fwdtab = NULL;
		}
	}
break;
case 53:
#line 475 "ns_parser.y"
{
		current_options->axfr_src = yyvsp[0].ip_addr;
	}
break;
case 54:
#line 479 "ns_parser.y"
{
		if (current_options->query_acl) {
			parser_warning(0,
			      "options allow-query acl already set; skipping");
			free_ip_match_list(yyvsp[-1].iml);
		} else 
			current_options->query_acl = yyvsp[-1].iml;
	}
break;
case 55:
#line 488 "ns_parser.y"
{
		if (current_options->recursion_acl) {
			parser_warning(0,
			      "options allow-recursion acl already set; skipping");
			free_ip_match_list(yyvsp[-1].iml);
		} else
			current_options->recursion_acl = yyvsp[-1].iml;
	}
break;
case 56:
#line 497 "ns_parser.y"
{
		if (current_options->transfer_acl) {
			parser_warning(0,
			   "options allow-transfer acl already set; skipping");
			free_ip_match_list(yyvsp[-1].iml);
		} else 
			current_options->transfer_acl = yyvsp[-1].iml;
	}
break;
case 57:
#line 506 "ns_parser.y"
{
		if (current_options->sortlist) {
			parser_warning(0,
			      "options sortlist already set; skipping");
			free_ip_match_list(yyvsp[-1].iml);
		} else
			current_options->sortlist = yyvsp[-1].iml;
	}
break;
case 58:
#line 515 "ns_parser.y"
{
		if (current_options->also_notify) {
			parser_warning(0,
			    "duplicate also-notify clause: overwriting");
			free_also_notify(current_options);
			current_options->also_notify = NULL;
		}
	}
break;
case 60:
#line 525 "ns_parser.y"
{
		if (current_options->blackhole_acl) {
			parser_warning(0,
			      "options blackhole already set; skipping");
			free_ip_match_list(yyvsp[-1].iml);
		} else
			current_options->blackhole_acl = yyvsp[-1].iml;
	}
break;
case 61:
#line 534 "ns_parser.y"
{
		if (current_options->topology) {
			parser_warning(0,
			      "options topology already set; skipping");
			free_ip_match_list(yyvsp[-1].iml);
		} else
			current_options->topology = yyvsp[-1].iml;
	}
break;
case 62:
#line 543 "ns_parser.y"
{
		/* To get around the $$ = $1 default rule. */
	}
break;
case 64:
#line 548 "ns_parser.y"
{
		current_options->transfer_format = yyvsp[0].axfr_fmt;
	}
break;
case 65:
#line 552 "ns_parser.y"
{
		current_options->max_transfer_time_in = yyvsp[0].num * 60;
	}
break;
case 66:
#line 556 "ns_parser.y"
{
		current_options->serial_queries = yyvsp[0].num;
	}
break;
case 67:
#line 560 "ns_parser.y"
{
		current_options->clean_interval = yyvsp[0].num * 60;
	}
break;
case 68:
#line 564 "ns_parser.y"
{
		current_options->interface_interval = yyvsp[0].num * 60;
	}
break;
case 69:
#line 568 "ns_parser.y"
{
		current_options->stats_interval = yyvsp[0].num * 60;
	}
break;
case 70:
#line 572 "ns_parser.y"
{
		current_options->max_host_stats = yyvsp[0].num;
	}
break;
case 71:
#line 576 "ns_parser.y"
{
		current_options->max_log_size_ixfr = yyvsp[0].ul_int;
	}
break;
case 72:
#line 580 "ns_parser.y"
{
		current_options->max_ncache_ttl = yyvsp[0].num;
	}
break;
case 73:
#line 584 "ns_parser.y"
{
		current_options->lame_ttl = yyvsp[0].num;
	}
break;
case 74:
#line 588 "ns_parser.y"
{
		current_options->heartbeat_interval = yyvsp[0].num * 60;
	}
break;
case 75:
#line 592 "ns_parser.y"
{
		set_global_boolean_option(current_options,
                                          OPTION_NODIALUP, !yyvsp[0].num);
	}
break;
case 76:
#line 597 "ns_parser.y"
{
		if (current_options->ordering)
			free_rrset_order_list(current_options->ordering);
		current_options->ordering = yyvsp[-1].rol;
	}
break;
case 77:
#line 603 "ns_parser.y"
{
		set_global_boolean_option(current_options,
					  OPTION_TREAT_CR_AS_SPACE, yyvsp[0].num);
	}
break;
case 78:
#line 608 "ns_parser.y"
{
		if (yyvsp[0].num >= 1)
			current_options->minroots = yyvsp[0].num;
	}
break;
case 84:
#line 628 "ns_parser.y"
{
		ns_ctl_add(&current_controls, ns_ctl_new_inet(yyvsp[-6].ip_addr, yyvsp[-4].us_int, yyvsp[-1].iml));
	}
break;
case 85:
#line 634 "ns_parser.y"
{
		parser_warning(0, "Ignoring BIND 9 inet control clause");
		free_ip_match_list(yyvsp[-5].iml);
	}
break;
case 86:
#line 641 "ns_parser.y"
{
		parser_warning(0, "Ignoring BIND 9 inet control clause");
		free_ip_match_list(yyvsp[-5].iml);
	}
break;
case 87:
#line 646 "ns_parser.y"
{
#ifndef NO_SOCKADDR_UN
		ns_ctl_add(&current_controls, ns_ctl_new_unix(yyvsp[-6].cp, yyvsp[-4].num, yyvsp[-2].num, yyvsp[0].num));
#endif
		freestr(yyvsp[-6].cp);
	}
break;
case 89:
#line 656 "ns_parser.y"
{
		rrset_order_list rol;

		rol = new_rrset_order_list();
		if (yyvsp[-1].roe != NULL) {
			add_to_rrset_order_list(rol, yyvsp[-1].roe);
		}
		
		yyval.rol = rol;
	}
break;
case 90:
#line 667 "ns_parser.y"
{
		if (yyvsp[-1].roe != NULL) {
			add_to_rrset_order_list(yyvsp[-2].rol, yyvsp[-1].roe);
		}
		yyval.rol = yyvsp[-2].rol;
	}
break;
case 91:
#line 676 "ns_parser.y"
{
		yyval.s_int = C_ANY;
	}
break;
case 92:
#line 680 "ns_parser.y"
{
		symbol_value value;

		if (lookup_symbol(constants, yyvsp[0].cp, SYM_CLASS, &value))
			yyval.s_int = value.integer;
		else {
			parser_error(0, "unknown class '%s'; using ANY", yyvsp[0].cp);
			yyval.s_int = C_ANY;
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 93:
#line 694 "ns_parser.y"
{
		yyval.s_int = ns_t_any;
	}
break;
case 94:
#line 698 "ns_parser.y"
{
		int success;

		if (strcmp(yyvsp[0].cp, "*") == 0) {
			yyval.s_int = ns_t_any;
		} else {
			yyval.s_int = __sym_ston(__p_type_syms, yyvsp[0].cp, &success);
			if (success == 0) {
				yyval.s_int = ns_t_any;
				parser_error(0,
					     "unknown type '%s'; assuming ANY",
					     yyvsp[0].cp);
			}
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 95:
#line 716 "ns_parser.y"
{
		yyval.cp = savestr("*", 1);
	}
break;
case 96:
#line 720 "ns_parser.y"
{
		if (strcmp(".",yyvsp[0].cp) == 0 || strcmp("*.",yyvsp[0].cp) == 0) {
			yyval.cp = savestr("*", 1);
			(void)freestr(yyvsp[0].cp);
		} else {
			yyval.cp = yyvsp[0].cp ;
		}
		/* XXX Should do any more name validation here? */
	}
break;
case 97:
#line 732 "ns_parser.y"
{
		enum ordering o;

		if (strlen(yyvsp[0].cp) == 0) {
			parser_error(0, "null order name");
			yyval.roe = NULL ;
		} else {
			o = lookup_ordering(yyvsp[0].cp);
			if (o == unknown_order) {
				o = (enum ordering)DEFAULT_ORDERING;
				parser_error(0,
					     "invalid order name '%s'; using %s",
					     yyvsp[0].cp, p_order(o));
			}
			
			(void)freestr(yyvsp[0].cp);
			
			yyval.roe = new_rrset_order_element(yyvsp[-4].s_int, yyvsp[-3].s_int, yyvsp[-2].cp, o);
		}
	}
break;
case 98:
#line 755 "ns_parser.y"
{
		yyval.axfr_fmt = axfr_one_answer;
	}
break;
case 99:
#line 759 "ns_parser.y"
{
		yyval.axfr_fmt = axfr_many_answers;
	}
break;
case 100:
#line 764 "ns_parser.y"
{ yyval.ip_addr = yyvsp[0].ip_addr; }
break;
case 101:
#line 765 "ns_parser.y"
{ yyval.ip_addr.s_addr = htonl(INADDR_ANY); }
break;
case 102:
#line 768 "ns_parser.y"
{ yyval.us_int = yyvsp[0].us_int; }
break;
case 103:
#line 769 "ns_parser.y"
{ yyval.us_int = htons(0); }
break;
case 104:
#line 773 "ns_parser.y"
{
		current_options->query_source.sin_addr = yyvsp[0].ip_addr;
	}
break;
case 105:
#line 779 "ns_parser.y"
{
		current_options->query_source.sin_port = yyvsp[0].us_int;
	}
break;
case 110:
#line 790 "ns_parser.y"
{ yyval.us_int = htons(NS_DEFAULTPORT); }
break;
case 111:
#line 791 "ns_parser.y"
{ yyval.us_int = yyvsp[0].us_int; }
break;
case 112:
#line 794 "ns_parser.y"
{ yyval.us_int = htons(0); }
break;
case 113:
#line 795 "ns_parser.y"
{ yyval.us_int = yyvsp[0].us_int; }
break;
case 114:
#line 800 "ns_parser.y"
{ 
		yyval.num = 1;	
	}
break;
case 115:
#line 804 "ns_parser.y"
{ 
		yyval.num = 1;	
	}
break;
case 116:
#line 808 "ns_parser.y"
{ 
		yyval.num = 0;	
	}
break;
case 117:
#line 812 "ns_parser.y"
{ 
		yyval.num = 0;	
	}
break;
case 118:
#line 816 "ns_parser.y"
{ 
		if (yyvsp[0].num == 1 || yyvsp[0].num == 0) {
			yyval.num = yyvsp[0].num;
		} else {
			parser_warning(0,
				       "number should be 0 or 1; assuming 1");
			yyval.num = 1;
		}
	}
break;
case 119:
#line 828 "ns_parser.y"
{
		yyval.s_int = primary_trans;
	}
break;
case 120:
#line 832 "ns_parser.y"
{
		yyval.s_int = secondary_trans;
	}
break;
case 121:
#line 836 "ns_parser.y"
{
		yyval.s_int = response_trans;
	}
break;
case 122:
#line 842 "ns_parser.y"
{
		yyval.s_int = warn;
	}
break;
case 123:
#line 846 "ns_parser.y"
{
		yyval.s_int = fail;
	}
break;
case 124:
#line 850 "ns_parser.y"
{
		yyval.s_int = ignore;
	}
break;
case 125:
#line 856 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_FORWARD_ONLY, 1);
	}
break;
case 126:
#line 861 "ns_parser.y"
{
		set_global_boolean_option(current_options,
			OPTION_FORWARD_ONLY, 0);
	}
break;
case 127:
#line 866 "ns_parser.y"
{
		parser_warning(0, "forward if-no-answer is unimplemented");
	}
break;
case 128:
#line 870 "ns_parser.y"
{
		parser_warning(0, "forward if-no-domain is unimplemented");
	}
break;
case 129:
#line 876 "ns_parser.y"
{
		current_options->data_size = yyvsp[0].ul_int;
	}
break;
case 130:
#line 880 "ns_parser.y"
{
		current_options->stack_size = yyvsp[0].ul_int;
	}
break;
case 131:
#line 884 "ns_parser.y"
{
		current_options->core_size = yyvsp[0].ul_int;
	}
break;
case 132:
#line 888 "ns_parser.y"
{
		current_options->files = yyvsp[0].ul_int;
	}
break;
case 133:
#line 894 "ns_parser.y"
{
		u_long result;

		if (unit_to_ulong(yyvsp[0].cp, &result))
			yyval.ul_int = result;
		else {
			parser_error(0, "invalid unit string '%s'", yyvsp[0].cp);
			/* 0 means "use default" */
			yyval.ul_int = 0;
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 134:
#line 907 "ns_parser.y"
{	
		yyval.ul_int = (u_long)yyvsp[0].num;
	}
break;
case 135:
#line 911 "ns_parser.y"
{
		yyval.ul_int = 0;
	}
break;
case 136:
#line 915 "ns_parser.y"
{
		yyval.ul_int = ULONG_MAX;
	}
break;
case 137:
#line 921 "ns_parser.y"
{
		current_options->transfers_in = (u_long) yyvsp[0].num;
	}
break;
case 138:
#line 925 "ns_parser.y"
{
		current_options->transfers_out = (u_long) yyvsp[0].num;
	}
break;
case 139:
#line 929 "ns_parser.y"
{
		current_options->transfers_per_ns = (u_long) yyvsp[0].num;
	}
break;
case 142:
#line 939 "ns_parser.y"
{
		/* nothing */
	}
break;
case 143:
#line 943 "ns_parser.y"
{
		/* nothing */
	}
break;
case 144:
#line 949 "ns_parser.y"
{
	  	add_global_forwarder(current_options, yyvsp[0].ip_addr);
	}
break;
case 147:
#line 959 "ns_parser.y"
{
		/* nothing */
	}
break;
case 148:
#line 963 "ns_parser.y"
{
		/* nothing */
	}
break;
case 149:
#line 969 "ns_parser.y"
{
	  	add_global_also_notify(current_options, yyvsp[0].ip_addr);
	}
break;
case 150:
#line 979 "ns_parser.y"
{
		current_logging = begin_logging();
	}
break;
case 151:
#line 983 "ns_parser.y"
{
		end_logging(current_logging, 1);
		current_logging = NULL;
	}
break;
case 155:
#line 995 "ns_parser.y"
{
		current_category = yyvsp[0].s_int;
	}
break;
case 157:
#line 1000 "ns_parser.y"
{
		chan_type = log_null;
		chan_flags = 0;
		chan_level = log_info;
	}
break;
case 158:
#line 1006 "ns_parser.y"
{
		log_channel current_channel = NULL;

		if (lookup_channel(yyvsp[-4].cp) != NULL) {
			parser_error(0, "can't redefine channel '%s'", yyvsp[-4].cp);
		} else {
			switch (chan_type) {
			case log_file:
				current_channel =
					log_new_file_channel(chan_flags,
							     chan_level,
							     chan_name, NULL,
							     chan_versions,
							     chan_max_size);
				log_set_file_owner(current_channel,
						   user_id, group_id);
				chan_name = freestr(chan_name);
				break;
			case log_syslog:
				current_channel =
					log_new_syslog_channel(chan_flags,
							       chan_level,
							       chan_facility);
				break;
			case log_null:
				current_channel = log_new_null_channel();
				break;
			default:
				ns_panic(ns_log_parser, 1,
					 "unknown channel type: %d",
					 chan_type);
			}
			if (current_channel == NULL)
				ns_panic(ns_log_parser, 0,
					 "couldn't create channel");
			define_channel(yyvsp[-4].cp, current_channel);
		}
		(void)freestr(yyvsp[-4].cp);
	}
break;
case 159:
#line 1048 "ns_parser.y"
{
		symbol_value value;

		if (lookup_symbol(constants, yyvsp[0].cp, SYM_LOGGING, &value)) {
			chan_level = value.integer;
		} else {
			parser_error(0, "unknown severity '%s'", yyvsp[0].cp);
			chan_level = log_debug(99);
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 160:
#line 1060 "ns_parser.y"
{
		chan_level = log_debug(1);
	}
break;
case 161:
#line 1064 "ns_parser.y"
{
		chan_level = yyvsp[0].num;
	}
break;
case 162:
#line 1068 "ns_parser.y"
{
		chan_level = 0;
		chan_flags |= LOG_USE_CONTEXT_LEVEL|LOG_REQUIRE_DEBUG;
	}
break;
case 163:
#line 1075 "ns_parser.y"
{
		chan_versions = yyvsp[0].num;
	}
break;
case 164:
#line 1079 "ns_parser.y"
{
		chan_versions = LOG_MAX_VERSIONS;
	}
break;
case 165:
#line 1085 "ns_parser.y"
{
		chan_max_size = yyvsp[0].ul_int;
	}
break;
case 166:
#line 1091 "ns_parser.y"
{
		chan_versions = 0;
		chan_max_size = ULONG_MAX;
	}
break;
case 167:
#line 1096 "ns_parser.y"
{
		chan_max_size = ULONG_MAX;
	}
break;
case 168:
#line 1100 "ns_parser.y"
{
		chan_versions = 0;
	}
break;
case 171:
#line 1108 "ns_parser.y"
{
		chan_flags |= LOG_CLOSE_STREAM;
		chan_type = log_file;
		chan_name = yyvsp[-1].cp;
	}
break;
case 172:
#line 1116 "ns_parser.y"
{ yyval.cp = yyvsp[0].cp; }
break;
case 173:
#line 1117 "ns_parser.y"
{ yyval.cp = savestr("syslog", 1); }
break;
case 174:
#line 1120 "ns_parser.y"
{ yyval.s_int = LOG_DAEMON; }
break;
case 175:
#line 1122 "ns_parser.y"
{
		symbol_value value;

		if (lookup_symbol(constants, yyvsp[0].cp, SYM_SYSLOG, &value)) {
			yyval.s_int = value.integer;
		} else {
			parser_error(0, "unknown facility '%s'", yyvsp[0].cp);
			yyval.s_int = LOG_DAEMON;
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 176:
#line 1136 "ns_parser.y"
{
		chan_type = log_syslog;
		chan_facility = yyvsp[0].s_int;
	}
break;
case 177:
#line 1142 "ns_parser.y"
{ /* nothing to do */ }
break;
case 178:
#line 1143 "ns_parser.y"
{ /* nothing to do */ }
break;
case 179:
#line 1145 "ns_parser.y"
{
		chan_type = log_null;
	}
break;
case 180:
#line 1148 "ns_parser.y"
{ /* nothing to do */ }
break;
case 181:
#line 1150 "ns_parser.y"
{
		if (yyvsp[0].num)
			chan_flags |= LOG_TIMESTAMP;
		else
			chan_flags &= ~LOG_TIMESTAMP;
	}
break;
case 182:
#line 1157 "ns_parser.y"
{
		if (yyvsp[0].num)
			chan_flags |= LOG_PRINT_CATEGORY;
		else
			chan_flags &= ~LOG_PRINT_CATEGORY;
	}
break;
case 183:
#line 1164 "ns_parser.y"
{
		if (yyvsp[0].num)
			chan_flags |= LOG_PRINT_LEVEL;
		else
			chan_flags &= ~LOG_PRINT_LEVEL;
	}
break;
case 188:
#line 1178 "ns_parser.y"
{ yyval.cp = savestr("null", 1); }
break;
case 189:
#line 1182 "ns_parser.y"
{
		log_channel channel;

		if (current_category >= 0) {
			channel = lookup_channel(yyvsp[0].cp);
			if (channel != NULL) {
				add_log_channel(current_logging,
						current_category, channel);
			} else
				parser_error(0, "unknown channel '%s'", yyvsp[0].cp);
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 194:
#line 1203 "ns_parser.y"
{ yyval.cp = savestr("default", 1); }
break;
case 195:
#line 1204 "ns_parser.y"
{ yyval.cp = savestr("notify", 1); }
break;
case 196:
#line 1208 "ns_parser.y"
{
		symbol_value value;

		if (lookup_symbol(constants, yyvsp[0].cp, SYM_CATEGORY, &value))
			yyval.s_int = value.integer;
		else {
			parser_error(0, "invalid logging category '%s'",
				     yyvsp[0].cp);
			yyval.s_int = -1;
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 197:
#line 1227 "ns_parser.y"
{
		const char *ip_printable;
		symbol_value value;
		
		ip_printable = inet_ntoa(yyvsp[0].ip_addr);
		value.pointer = NULL;
		if (lookup_symbol(symtab, ip_printable, SYM_SERVER, NULL))
			seen_server = 1;
		else
			seen_server = 0;
		if (seen_server)
			parser_error(0, "cannot redefine server '%s'", 
				     ip_printable);
		else
			define_symbol(symtab, ip_printable, SYM_SERVER, value,
				      0);
		current_server = begin_server(yyvsp[0].ip_addr);
	}
break;
case 198:
#line 1246 "ns_parser.y"
{
		end_server(current_server, !seen_server);
	}
break;
case 201:
#line 1256 "ns_parser.y"
{
		set_server_option(current_server, SERVER_INFO_BOGUS, yyvsp[0].num);
	}
break;
case 202:
#line 1260 "ns_parser.y"
{
		set_server_option(current_server, SERVER_INFO_SUPPORT_IXFR, yyvsp[0].num);
	}
break;
case 203:
#line 1264 "ns_parser.y"
{
		set_server_transfers(current_server, (int)yyvsp[0].num);
	}
break;
case 204:
#line 1268 "ns_parser.y"
{
		set_server_transfer_format(current_server, yyvsp[0].axfr_fmt);
	}
break;
case 206:
#line 1273 "ns_parser.y"
{
		set_server_option(current_server, SERVER_INFO_EDNS, yyvsp[0].num);
	}
break;
case 208:
#line 1284 "ns_parser.y"
{
		ip_match_list iml;
		
		iml = new_ip_match_list();
		if (yyvsp[-1].ime != NULL)
			add_to_ip_match_list(iml, yyvsp[-1].ime);
		yyval.iml = iml;
	}
break;
case 209:
#line 1293 "ns_parser.y"
{
		if (yyvsp[-1].ime != NULL)
			add_to_ip_match_list(yyvsp[-2].iml, yyvsp[-1].ime);
		yyval.iml = yyvsp[-2].iml;
	}
break;
case 211:
#line 1302 "ns_parser.y"
{
		if (yyvsp[0].ime != NULL)
			ip_match_negate(yyvsp[0].ime);
		yyval.ime = yyvsp[0].ime;
	}
break;
case 212:
#line 1308 "ns_parser.y"
{
		char *key_name;
		struct dst_key *dst_key;

		key_name = canonical_name(yyvsp[0].cp);
		if (key_name == NULL) {
			parser_error(0, "can't make key name '%s' canonical",
				     yyvsp[0].cp);
			key_name = savestr("__bad_key__", 1);
		}
		dst_key = find_key(key_name, NULL);
		if (dst_key == NULL) {
			parser_error(0, "key \"%s\" not found", key_name);
			yyval.ime = NULL;
		}
		else
			yyval.ime = new_ip_match_key(dst_key);
	        (void)freestr(key_name);
		freestr(yyvsp[0].cp);
	}
break;
case 213:
#line 1331 "ns_parser.y"
{
		yyval.ime = new_ip_match_pattern(yyvsp[0].ip_addr, 32);
	}
break;
case 214:
#line 1335 "ns_parser.y"
{
		if (yyvsp[0].num < 0 || yyvsp[0].num > 32) {
			parser_error(0, "mask bits out of range; skipping");
			yyval.ime = NULL;
		} else {
			yyval.ime = new_ip_match_pattern(yyvsp[-2].ip_addr, yyvsp[0].num);
			if (yyval.ime == NULL)
				parser_error(0, 
					   "address/mask mismatch; skipping");
		}
	}
break;
case 215:
#line 1347 "ns_parser.y"
{
		struct in_addr ia;

		if (yyvsp[-2].num > 255) {
			parser_error(0, "address out of range; skipping");
			yyval.ime = NULL;
		} else {
			if (yyvsp[0].num < 0 || yyvsp[0].num > 32) {
				parser_error(0,
					"mask bits out of range; skipping");
					yyval.ime = NULL;
			} else {
				ia.s_addr = htonl((yyvsp[-2].num & 0xff) << 24);
				yyval.ime = new_ip_match_pattern(ia, yyvsp[0].num);
				if (yyval.ime == NULL)
					parser_error(0, 
					   "address/mask mismatch; skipping");
			}
		}
	}
break;
case 217:
#line 1369 "ns_parser.y"
{
		char name[256];

		/*
		 * We want to be able to clean up this iml later so
		 * we give it a name and treat it like any other acl.
		 */
		sprintf(name, "__internal_%p", yyvsp[-1].iml);
		define_acl(name, yyvsp[-1].iml);
  		yyval.ime = new_ip_match_indirect(yyvsp[-1].iml);
	}
break;
case 218:
#line 1383 "ns_parser.y"
{
		ip_match_list iml;

		iml = lookup_acl(yyvsp[0].cp);
		if (iml == NULL) {
			parser_error(0, "unknown ACL '%s'", yyvsp[0].cp);
			yyval.ime = NULL;
		} else
			yyval.ime = new_ip_match_indirect(iml);
		(void)freestr(yyvsp[0].cp);
	}
break;
case 219:
#line 1401 "ns_parser.y"
{
		struct dst_key *dst_key;
		char *key_name;

		key_name = canonical_name(yyvsp[0].cp);
		if (key_name == NULL) {
			parser_error(0, "can't make key name '%s' canonical",
				     yyvsp[0].cp);
			yyval.keyi = NULL;
		} else {
			dst_key = lookup_key(key_name);
			if (dst_key == NULL) {
				parser_error(0, "unknown key '%s'", key_name);
				yyval.keyi = NULL;
			} else
				yyval.keyi = dst_key;
			key_name = freestr(key_name);
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 220:
#line 1424 "ns_parser.y"
{
		if (yyvsp[0].keyi == NULL)
			parser_error(0, "empty key not added to server list ");
		else
			add_server_key_info(current_server, yyvsp[0].keyi);
	}
break;
case 228:
#line 1445 "ns_parser.y"
{
		current_algorithm = NULL;
		current_secret = NULL;
	}
break;
case 229:
#line 1450 "ns_parser.y"
{
		struct dst_key *dst_key;
		char *key_name;

		key_name = canonical_name(yyvsp[-3].cp);
		if (key_name == NULL) {
			parser_error(0, "can't make key name '%s' canonical",
				     yyvsp[-3].cp);
		} else if (lookup_key(key_name) != NULL) {
			parser_error(0, "can't redefine key '%s'", key_name);
		} else {
			if (current_algorithm == NULL ||
			    current_secret == NULL)  {
				parser_error(0, "skipping bad key '%s'",
					     key_name);
			} else {
				dst_key = new_key_info(key_name,
						       current_algorithm,
						       current_secret);
				if (dst_key != NULL) {
					define_key(key_name, dst_key);
					if (secretkey_info == NULL)
						secretkey_info =
							new_key_info_list();
					add_to_key_info_list(secretkey_info,
							     dst_key);
				}
			}
		}
		if (key_name != NULL)
			key_name = freestr(key_name);
		if (current_algorithm != NULL)
			current_algorithm = freestr(current_algorithm);
		if (current_secret != NULL)
			current_secret = freestr(current_secret);
		(void)freestr(yyvsp[-3].cp);
	}
break;
case 230:
#line 1490 "ns_parser.y"
{
		current_algorithm = yyvsp[-1].cp;
		current_secret = yyvsp[0].cp;
	}
break;
case 231:
#line 1495 "ns_parser.y"
{
		current_algorithm = yyvsp[0].cp;
		current_secret = yyvsp[-1].cp;
	}
break;
case 232:
#line 1500 "ns_parser.y"
{
		current_algorithm = NULL;
		current_secret = NULL;
	}
break;
case 233:
#line 1506 "ns_parser.y"
{ yyval.cp = yyvsp[-1].cp; }
break;
case 234:
#line 1509 "ns_parser.y"
{ yyval.cp = yyvsp[-1].cp; }
break;
case 235:
#line 1517 "ns_parser.y"
{
		if (lookup_acl(yyvsp[-3].cp) != NULL) {
			parser_error(0, "can't redefine ACL '%s'", yyvsp[-3].cp);
		} else
			define_acl(yyvsp[-3].cp, yyvsp[-1].iml);
		(void)freestr(yyvsp[-3].cp);
	}
break;
case 236:
#line 1531 "ns_parser.y"
{
		int sym_type;
		symbol_value value;
		char *zone_name;

		if (!seen_options && !logged_options_error) {
			parser_error(0,
             "no options statement before first zone; using previous/default");
			logged_options_error = 1;
		}
		sym_type = SYM_ZONE | (yyvsp[0].num & 0xffff);
		value.pointer = NULL;
		zone_name = canonical_name(yyvsp[-1].cp);
		if (zone_name == NULL) {
			parser_error(0, "can't make zone name '%s' canonical",
				     yyvsp[-1].cp);
			should_install = 0;
			zone_name = savestr("__bad_zone__", 1);
		} else {
			if (lookup_symbol(symtab, zone_name, sym_type, NULL)) {
				should_install = 0;
				parser_error(0,
					"cannot redefine zone '%s' class %s",
					     *zone_name ? zone_name : ".",
					     p_class(yyvsp[0].num));
			} else {
				should_install = 1;
				define_symbol(symtab, zone_name, sym_type,
					      value, 0);
			}
		}
		(void)freestr(yyvsp[-1].cp);
		current_zone = begin_zone(zone_name, yyvsp[0].num); 
	}
break;
case 237:
#line 1566 "ns_parser.y"
{
		end_zone(current_zone, should_install);
	}
break;
case 240:
#line 1576 "ns_parser.y"
{
		yyval.num = C_IN;
	}
break;
case 241:
#line 1580 "ns_parser.y"
{
		symbol_value value;

		if (lookup_symbol(constants, yyvsp[0].cp, SYM_CLASS, &value))
			yyval.num = value.integer;
		else {
			/* the zone validator will give the error */
			yyval.num = C_NONE;
		}
		(void)freestr(yyvsp[0].cp);
	}
break;
case 242:
#line 1594 "ns_parser.y"
{
		yyval.s_int = Z_MASTER;
	}
break;
case 243:
#line 1598 "ns_parser.y"
{
		yyval.s_int = Z_SLAVE;
	}
break;
case 244:
#line 1602 "ns_parser.y"
{
		yyval.s_int = Z_HINT;
	}
break;
case 245:
#line 1606 "ns_parser.y"
{
		yyval.s_int = Z_STUB;
	}
break;
case 246:
#line 1610 "ns_parser.y"
{
		yyval.s_int = Z_FORWARD;
	}
break;
case 249:
#line 1620 "ns_parser.y"
{
		if (!set_zone_type(current_zone, yyvsp[0].s_int))
			parser_warning(0, "zone type already set; skipping");
	}
break;
case 250:
#line 1625 "ns_parser.y"
{
		if (!set_zone_filename(current_zone, yyvsp[0].cp))
			parser_warning(0,
				       "zone filename already set; skipping");
	}
break;
case 251:
#line 1631 "ns_parser.y"
{
		if (!set_zone_ixfr_file(current_zone, yyvsp[0].cp))
			parser_warning(0,
				       "zone ixfr data base already set; skipping");
	}
break;
case 252:
#line 1637 "ns_parser.y"
{
		if (!set_zone_ixfr_tmp(current_zone, yyvsp[0].cp))
			parser_warning(0,
				       "zone ixfr temp filename already set; skipping");
	}
break;
case 253:
#line 1643 "ns_parser.y"
{
		set_zone_master_port(current_zone, yyvsp[-3].us_int);
	}
break;
case 254:
#line 1647 "ns_parser.y"
{
		set_zone_transfer_source(current_zone, yyvsp[0].ip_addr);
	}
break;
case 255:
#line 1651 "ns_parser.y"
{
		if (!set_zone_checknames(current_zone, (enum severity)yyvsp[0].s_int))
			parser_warning(0,
	                              "zone checknames already set; skipping");
	}
break;
case 256:
#line 1657 "ns_parser.y"
{
		if (!set_zone_update_acl(current_zone, yyvsp[-1].iml))
			parser_warning(0,
				      "zone update acl already set; skipping");
	}
break;
case 257:
#line 1663 "ns_parser.y"
{
		if (!set_zone_query_acl(current_zone, yyvsp[-1].iml))
			parser_warning(0,
				      "zone query acl already set; skipping");
	}
break;
case 258:
#line 1669 "ns_parser.y"
{
		if (!set_zone_transfer_acl(current_zone, yyvsp[-1].iml))
			parser_warning(0,
				    "zone transfer acl already set; skipping");
	}
break;
case 260:
#line 1676 "ns_parser.y"
{
		struct zoneinfo *zp = current_zone.opaque;
		if (zp->z_fwdtab) {
                	free_forwarders(zp->z_fwdtab);
			zp->z_fwdtab = NULL;
		}

	}
break;
case 262:
#line 1686 "ns_parser.y"
{
		if (!set_zone_transfer_time_in(current_zone, yyvsp[0].num*60))
			parser_warning(0,
		       "zone max transfer time (in) already set; skipping");
	}
break;
case 263:
#line 1692 "ns_parser.y"
{
		set_zone_max_log_size_ixfr(current_zone, yyvsp[0].ul_int);
        }
break;
case 264:
#line 1696 "ns_parser.y"
{
		set_zone_notify(current_zone, notify_explicit);
	}
break;
case 265:
#line 1700 "ns_parser.y"
{
		if (yyvsp[0].num)
			set_zone_notify(current_zone, notify_yes);
		else
			set_zone_notify(current_zone, notify_no);
	}
break;
case 266:
#line 1707 "ns_parser.y"
{
		set_zone_maintain_ixfr_base(current_zone, yyvsp[0].num);
	}
break;
case 267:
#line 1711 "ns_parser.y"
{
		/* flags proto alg key */
		set_zone_pubkey(current_zone, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].cp);
	}
break;
case 268:
#line 1716 "ns_parser.y"
{
		/* flags proto alg key */
		char *endp;
		int flags = (int) strtol(yyvsp[-3].cp, &endp, 0);
		if (*endp != '\0')
			ns_panic(ns_log_parser, 1,
				 "Invalid flags string: %s", yyvsp[-3].cp);
		set_zone_pubkey(current_zone, flags, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].cp);

	}
break;
case 270:
#line 1728 "ns_parser.y"
{
		 set_zone_dialup(current_zone, yyvsp[0].num);
	}
break;
case 272:
#line 1735 "ns_parser.y"
{
		/* nothing */
	}
break;
case 273:
#line 1739 "ns_parser.y"
{
		/* nothing */
	}
break;
case 274:
#line 1745 "ns_parser.y"
{
	  	add_zone_master(current_zone, yyvsp[0].ip_addr, NULL);
	}
break;
case 275:
#line 1749 "ns_parser.y"
{
		add_zone_master(current_zone, yyvsp[-2].ip_addr, yyvsp[0].keyi);
	}
break;
case 278:
#line 1759 "ns_parser.y"
{
		/* nothing */
	}
break;
case 279:
#line 1763 "ns_parser.y"
{
		/* nothing */
	}
break;
case 280:
#line 1769 "ns_parser.y"
{
	  	add_zone_notify(current_zone, yyvsp[0].ip_addr);
	}
break;
case 281:
#line 1775 "ns_parser.y"
{
		set_zone_boolean_option(current_zone, OPTION_FORWARD_ONLY, 1);
	}
break;
case 282:
#line 1779 "ns_parser.y"
{
		set_zone_boolean_option(current_zone, OPTION_FORWARD_ONLY, 0);
	}
break;
case 283:
#line 1785 "ns_parser.y"
{
		set_zone_forward(current_zone);
	}
break;
case 285:
#line 1792 "ns_parser.y"
{
		/* nothing */
	}
break;
case 286:
#line 1796 "ns_parser.y"
{
		/* nothing */
	}
break;
case 287:
#line 1802 "ns_parser.y"
{
	  	add_zone_forwarder(current_zone, yyvsp[0].ip_addr);
	}
break;
case 288:
#line 1812 "ns_parser.y"
{
	}
break;
case 289:
#line 1816 "ns_parser.y"
{
		/* nothing */
	}
break;
case 290:
#line 1820 "ns_parser.y"
{
		/* nothing */
	}
break;
case 291:
#line 1825 "ns_parser.y"
{
		/* name flags proto alg key */
		set_trusted_key(yyvsp[-4].cp, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].cp);
	}
break;
case 292:
#line 1830 "ns_parser.y"
{
		/* name flags proto alg key */
		char *endp;
		int flags = (int) strtol(yyvsp[-3].cp, &endp, 0);
		if (*endp != '\0')
			ns_panic(ns_log_parser, 1,
				 "Invalid flags string: %s", yyvsp[-3].cp);
		set_trusted_key(yyvsp[-4].cp, flags, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].cp);
	}
break;
case 293:
#line 1846 "ns_parser.y"
{
		if (yyvsp[0].num < 0 || yyvsp[0].num > 65535) {
		  	parser_warning(0, 
			  "invalid IP port number '%d'; setting port to 0",
			               (int)yyvsp[0].num);
			yyvsp[0].num = 0;
		} else
			yyval.us_int = htons(yyvsp[0].num);
	}
break;
#line 3246 "y.tab.c"
    }
    yystk.ssp -= yym;
    yystate = *yystk.ssp;
    yystk.vsp -= yym;
    yym = yylhs[yyn];
    yych = yychar;
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystk.ssp = YYFINAL;
        *++yystk.vsp = yyval;
        if (yych < 0)
        {
            if ((yych = YYLEX) < 0) yych = 0;
            yychar = yych;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yych <= YYMAXTOKEN) yys = yyname[yych];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yych, yys);
            }
#endif
        }
        if (yych == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystk.ssp, yystate);
#endif
    if (yystk.ssp >= yystk.sslim && yygrowstack(&yystk))
        goto yyoverflow;
    *++yystk.ssp = yystate;
    *++yystk.vsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    YYFREESTACK(&yystk);
    return (1);
yyaccept:
    YYFREESTACK(&yystk);
    return (0);
}
